<?php
/**
 * @fileID: $Id: addtosection.php 7312 2011-08-19 12:08:00Z kostya $
 * @changedDate: $LastChangedDate: 2011-08-19 18:08:00 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsAddToSection extends JPlugin
{
	function plgJoomsuite_content_fieldsAddToSection( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}


	function onRenderField(&$obj, &$params, $type)
	{		
		if($type!="addtosection") return;		
		
		$selected = ($obj->field_value == 1) ? "checked='checked'" : "";#$params->get('selected', 1) ? "checked='checked'" : "";
		echo "<input type='checkbox' {$selected} name='addtosection_checkbox_{$obj->id}' value='1' /> ";
		return;
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		global $mainframe;
		if($type != 'addtosection') return;
		$db = &JFactory::getDBO();
		$sections = is_array( $params->get('section_id', 0) ) ? $params->get('section_id', 0) : array($params->get('section_id', 0));
		$checked = JRequest::getVar("addtosection_checkbox_{$id}", 0);		
		if( $row->id && $checked){			
			foreach( $sections AS $section_id ){
				$section_id = intval($section_id);
				$sql2 = "SELECT 1 FROM #__js_res_record_category WHERE record_id={$row->id} AND catid={$section_id}";
				$db->setQuery($sql2);
				$r = $db->loadObject();
				if( !$r ){
					$sql2 = "INSERT INTO #__js_res_record_category(catid, record_id, ordering, otime) VALUES ({$section_id}, {$row->id}, 0, '0000-00-00 00:00:00')";
					$db->setQuery($sql2);
					if (!$db->query()) {
						$this->setError($db->getErrorMsg());
						return false;
					}						
				}						
			}				
		}
		
		// Editing article
		$isAdmin = $mainframe->isAdmin() ? 1 : 0;
		$article_id = 0;
		
		if($isAdmin){
			$ids = JRequest::getVar('cid', 0);
			if(is_array($ids)) $article_id = intval($ids[0]);
		} else {
			$article_id = JRequest::getVar('article', 0);
		}
		
		#echo $article_id;die;
		
		if( $article_id && !$checked){
			foreach( $sections AS $section_id ){
				$section_id = intval($section_id);
				$sql2 = "SELECT 1 FROM #__js_res_record_category WHERE record_id={$row->id} AND catid={$section_id}";
				$db->setQuery($sql2);
				$r = $db->loadObject();
				if( $r ){
					$sql2 = "DELETE FROM #__js_res_record_category WHERE record_id={$row->id} AND catid={$section_id}";
					$db->setQuery($sql2);
					if (!$db->query()) {
						$this->setError($db->getErrorMsg());
						return false;
					}						
				}
			}
		}
		if($checked) $value = 1;				
		else $value = 0; 	
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
	}

}
?>
