<?php
/**
 * @fileID: $Id: bill2.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsBill2 extends JPlugin
{
	function plgJoomsuite_content_fieldsBill2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'bill2') return;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];

		$db = &JFactory::getDBO();

		$sql = "SELECT * FROM #__bills WHERE `published` = 1";
		$db->setQuery($sql);
		$bills = $db->loadObjectList();
		$options = array();

		$options[] =  JHTML::_('select.option', '', '' );
		foreach ($bills as $val) {
			$product_list =  unserialize( $val->product_list );
			$options[] =  JHTML::_('select.option', $val->id, $product_list[1]['title'] );
		}

		echo JHTML::_('select.genericlist', $options, "fields[$obj->id]", 'class="inputbox"', 'value', 'text', $obj->field_value );


	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'bill2') return;
		if(!$value) return;
		$value = trim($value);
	}


	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'bill2') return;
		if(!$field->field_value) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		global $itemid;
		$link = JURI::root().'index.php?option=com_jsbill&view=bill&bill='.$field->field_value;
		$out = '<a href="'.$link.'">'.$params->get('linkname').'</a>';
	}

}
?>
