<?php
/**
 * @fileID: $Id: jsgallery.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ('_JEXEC') or die('Restricted access');
/**
 *  
 * @author Nurlan
 *
 */
class JElementJSGallery extends JElement 
{
	function JSAddress() {
		parent::__construct();
	}
	
	function fetchElement($name, $value, &$node, $control_name) {
		$options[] = JHTML::_('select.option', 'yui', 'YUI');
		$options[] = JHTML::_('select.option', 'noobslide', 'Noobslide');
		
		$uid = uniqid('e');
		
		ob_start();
		
		echo JHTML::_('select.genericlist', $options, $control_name.'['.$name.'][0]', 'onchange="'.$uid.'setData('.$uid.'data[this.value]);"', 'value', 'text', $this->i($value, 0, null));
		
		JHTML::_('behavior.mootools');
		
		$skinData = is_array($value) && count($value) > 1 ? array_slice($value, 1) : array();
		
		$yuiData = array();
		$noobData = array();
		switch ($skinToShow = $this->i($value, 0, 'yui')) {
			case 'yui':
				$yuiData = $skinData;
				break;
			case 'noobslide':
				$noobData = $skinData;
				break;
		}
		
		$yuiData 	= addslashes($this->getYUIOptions($control_name.'['.$name.']', 		$yuiData));
		$noobData 	= addslashes($this->getNoobSlideData($control_name.'['.$name.']', 	$noobData));
		?>
		<script>
			var <?php echo $uid; ?>data = {
				'yui': '<?php echo $yuiData; ?>',
				'noobslide': '<?php echo $noobData; ?>'
			};

			function <?php echo $uid; ?>setData(data) {
				var c = $('<?php echo $control_name.$name; ?>_cont');
				if ( c ) {
					c.innerHTML = data;
				}
			}

			Window.onDomReady(function() {
				var skinSelect = $('<?php echo $control_name.$name.'0'?>');

				if (!skinSelect)
					return;
				
				<?php echo $uid; ?>setData(<?php echo $uid; ?>data[skinSelect.value]);
			});

			var skinSelect = $('<?php echo $control_name.$name.'0'?>');

			if (skinSelect) {			
				<?php echo $uid; ?>setData(<?php echo $uid; ?>data[skinSelect.value]);
			}
		</script>
		<div id="<?php echo $control_name.$name; ?>_cont" style="margin-top: 5px;"><?php echo $skinToShow == 'yui' ? stripslashes($yuiData) : stripslashes($noobData);?></div>
		<?php
		
		return ob_get_clean();
	}
	
	/**
	 * Fetches YUI gallery options
	 * 
	 * @param $name string Control name
	 * @param $data array The values.
	 * @param $offset int The value to start indexing the field names
	 * @return string Rendered HTML
	 */
	function getYUIOptions($name, $data, $offset = 1) {
		$iData = 0;
		
		$display = array(
			'Gallery with carousel',
			'Carousel of thumbnails',
			'First thumbnail',
			'Random thumbnail',
			'First picture',
			'Random picture'
		);
		
		$options = array();
		foreach ($display as $k => $v)
			$options[] = JHTML::_('select.option', $k, $v);

		$html = array();
		$html[] = '<table cellpadding="0" cellspacing="0"><tr><td>'.
			JText::_('Display type').'</td><td>'. 
			JHTML::_('select.genericlist', $options, $name.'['.$offset++.']', null, 'value', 'text', $this->i($data, $iData++, 0)).
			'</td></tr>';
		
		$html []= '<tr><td>'.JText::_('Number of pictures in carousel').'</td>'.
			'<td><input type="text" name="'.$name.'['.$offset++.']" value="'.htmlspecialchars($this->i($data, $iData++, ''), ENT_QUOTES, 'UTF-8').'" /></td></tr>';
		
		$html []= '<tr><td>'.JText::_('Show pictures on scroll').'</td>'.
			'<td>'.JHTML::_('select.booleanlist', $name.'['.$offset++.']', 'class="inputbox"', $this->i($data, $iData++, '')).'</td></tr>';
		
		$html []= '<tr><td>'.JText::_('Reveal Amount of the next page in carousel').'</td>'.
			'<td><input type="text" name="'.$name.'['.$offset++.']" value="'.htmlspecialchars($this->i($data, $iData++, 0), ENT_QUOTES, 'UTF-8').'" /></td></tr>';
		
		$html [] = '</table>';
		
		return str_replace("\n", '', implode('', $html));
	}
	
	/**
	 * Fetches NoobSlide gallery options
	 * 
	 * @param $name Control name
	 * @param $data array The values.
	 * @param $offset int The value to start indexing the field names
	 * @return string Rendered HTML
	 */
	function getNoobSlideData($name, $data, $offset = 1) {
		$iData = 0;
		
		$html = array();
		
		$display = array(
			JText::_('Gallery with thumbs and controls'), 
			JText::_('Gallery with thumbs'),
			JText::_('Gallery with controls'),
			JText::_('Thumbs'),
			JText::_('First thumbnail'),
			JText::_('Random thumbnail'),
			JText::_('First picture'),
			JText::_('Random picture')
		);
		$options = array();
		$i = 0;
		foreach ($display as $d) {
			$options[] = JHTML::_('select.option', $i++, $d);
		}
		
		$html[] = '<table cellpadding="0" cellspacing="0"><tr><td>'.JText::_('Display type').'</td><td>'.
			JHTML::_('select.genericlist', $options, $name.'['.$offset++.']', null, 'value', 'text', $this->i($data, $iData++, 0)).
			'</td></tr>';
		
		$html []= '<tr><td>'.JText::_('Thumbs per row').'</td>'.
			'<td><input type="text" name="'.$name.'['.$offset++.']" value="'.htmlspecialchars($this->i($data, $iData++, ''), ENT_QUOTES, 'UTF-8').'" /></td></tr>';
		
		$events = array(
			'mouseenter' => 'Mouse over',
			'click' => 'Click'
		);
		$options = array();
		foreach ($events as $k => $v)
			$options[] = JHTML::_('select.option', $k, JText::_($v));
			
		$html []= '<tr><td>'.JText::_('Scroll on').'</td>'.
			'<td>'.	JHTML::_('select.genericlist', $options, $name.'['.($offset++).']', null, 'value', 'text', $this->i($data, $iData++, 'mouseenter')).
			'</td></tr>';
		
		
		
		$transitions = array(
			'linear' => 'Linear',
			'Quad' => 'Quad',
			'Cubic' => 'Cubic',
			'Quart' => 'Quart',
			'Quint' => 'Quint',
			'Pow' => 'Pow',
			'Expo' => 'Exponential',
			'Circ' => 'Circular',
			'Sine' => 'Sine',
			'Back' => 'Back',
			'Bounce' => 'Bounce',
			'Elastic' => 'Elastic' 
		);
		
		$options = array();
		foreach ($transitions as $k => $v)
			$options[] = JHTML::_('select.option', $k, JText::_($v));
		
		$html []= '<tr><td colspan="2"><b>'.JText::_('Animation').'</b></td></tr>';
		
		
		$html []= '<tr><td>'.JText::_('Transition').'</td>'.
			'<td>'.	JHTML::_('select.genericlist', $options, $name.'['.($offset++).']', null, 'value', 'text', $this->i($data, $iData++, 'linear')).
			'</td></tr>';
		
		
		$transitionTypes = array(
			'easeIn' => 'easeIn', 
			'easeOut' => 'easeOut', 
			'easeInOut' => 'easeInOut'
		);
		
		$options = array();
		foreach ($transitionTypes as $k => $v)
			$options[] = JHTML::_('select.option', $k, JText::_($v));
			
		$html []= '<tr><td>'.JText::_('Transition type').'</td>'.
			'<td>'.	JHTML::_('select.genericlist', $options, $name.'['.($offset++).']', null, 'value', 'text', $this->i($data, $iData++, 'easeIn')).
			'</td></tr>';
		
		$null = null;
		$toolTip = JElement::fetchTooltip(
			JText::_('Transition time').' ('.JText::_('ms').')', 
			JText::_('The time in which animation will occur (in milliseconds)'), 
			$null, '_', '_'
		);
		
		$html []= '<tr><td>'.$toolTip.'</td>'.
			'<td><input type="text" name="'.$name.'['.$offset++.']" value="'.htmlspecialchars($this->i($data, $iData++, '300'), ENT_QUOTES, 'UTF-8').'" /></td></tr>';

		
		$toolTip = JElement::fetchTooltip(
			JText::_('Autoplay'), 
			JText::_('Autoplay on load'), 
			$null, '_', '_'
		);
		
		$html []= '<tr><td>'.$toolTip.'</td>'.
			'<td>'.JHTML::_('select.booleanlist', $name.'['.$offset++.']', 'class="inputbox"', $this->i($data, $iData++, 1), JText::_('Yes'), JText::_('No')).'</td></tr>';
		
		
		$null = null;
		$toolTip = JElement::fetchTooltip(
			JText::_('Slideshow interval').' ('.JText::_('ms').')', 
			JText::_('The time in which autoplay will change pictures (in milliseconds)'), 
			$null, '_', '_'
		);
		
		$html []= '<tr><td>'.$toolTip.'</td>'.
			'<td><input type="text" name="'.$name.'['.$offset++.']" value="'.htmlspecialchars($this->i($data, $iData++, '4000'), ENT_QUOTES, 'UTF-8').'" /></td></tr>';
		
		$display = array(
			'bottom' => JText::_('Bottom'), 
			'right' => JText::_('Right'),
			'left' => JText::_('Left'),
			'top' => JText::_('Top')
		);
		$options = array();
		$i = 0;
		foreach ($display as $d) {
			$options[] = JHTML::_('select.option', $i++, $d);
		}
		
		$html[] = '<tr><td>'.JText::_('Thumbnail positioning').'</td><td>'.
			JHTML::_('select.genericlist', $options, $name.'['.$offset++.']', null, 'value', 'text', $this->i($data, $iData++, 0)).
			'</td></tr>';
		
		$html[] = '</table>';
		
		return str_replace("\n", '', implode('', $html));
	}
	
	function i(&$array, $idx, $default = '') {
		if (isset($array[ $idx ]))
			return $array[ $idx ];
			
		return $default;
	}
}

?>