<?php
/**
 * @fileID: $Id: jsrelatefieldorder.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

// @entodo: I stoped here

class JElementJSRelateFieldOrder extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		JHTML::_('behavior.mootools');
		
		ob_start();
		?>
		<script>
			var fieldList<?php echo $name; ?> = $('js_sublist_show_relate_field');
			function makeOrderList<?php echo $name; ?>() {
				var oldVals = $$('#<?php echo $control_name.$name; ?> input');

				// empty the table.
				$('<?php echo $control_name.$name; ?>').getChildren().each(function(e) {
					e.remove();
				});

				var idx = 0;
				
				for (var i = 0; i < fieldList<?php echo $name; ?>.options.length; i++) {
					if (fieldList<?php echo $name; ?>.options[ i ].selected && fieldList<?php echo $name; ?>.options[ i ].value != 0) {
						var tr = new Element('tr');
						var td1 = new Element('td');
						var td2 = new Element('td');

						td1.setHTML(fieldList<?php echo $name; ?>.options[ i ].text);


						var val = fieldList<?php echo $name; ?>.options[ i ].value + '%_%%_%%_%' + fieldList<?php echo $name; ?>.options[ i ].text;
						td1.adopt(new Element('input', {
							type: 'hidden',
							name: '<?php echo $control_name, '[', $name, ']['?>' + idx + ']',
							value: val 
						}));						

						idx++;

						// The ordering
						var val2 = '0';
						for (var j = 0; j < oldVals.length; j+= 2) {
							if (oldVals[ j ].value == val && j < oldVals.length - 1) {
								val2 = oldVals[j + 1].value;
								break;
							}
						}
						

						td2.adopt(new Element('input', {
							type: 'text',
							size: '6',
							name: '<?php echo $control_name, '[', $name, ']['?>' + idx + ']',
							value: val2
						}));				

						idx++;
						
						tr.adopt([td1, td2]);

						$('<?php echo $control_name.$name; ?>').adopt(tr);
					}
				}
			}

			
			
			fieldList<?php echo $name; ?>.addEvent('change', makeOrderList<?php echo $name; ?>);
		</script>
		<table>
			<tbody id="<?php echo $control_name.$name; ?>">
<?php
		$selectedFields = array();
		
		if (is_array($value)) {
			for ($i = 0, $count = count($value), $idx = 0; $i < $count; $i += 2) {
				$varName = explode('%_%%_%%_%', $value[ $i ]);
				if (!isset($varName[ 1 ]))
					$varName[ 1 ] = '';
					
				$selectedFields [] = isset($varName[ 0 ]) ? $varName[ 0 ] : -1; 
				
				echo '<tr>';
				echo '<td>', htmlspecialchars($varName[ 1 ], ENT_QUOTES, 'UTF-8');
				echo '<input type="hidden" value="', htmlspecialchars($value[ $i ], ENT_QUOTES, 'UTF-8'), '" name=', $control_name, '[', $name, '][', $idx++, ']" /></td>';
				echo '<td><input type="text" size="6" value="', htmlspecialchars($value[$i + 1], ENT_QUOTES, 'UTF-8'), '" name=', $control_name, '[', $name, '][', $idx++, ']" /></td>';
				echo '</tr>';
			}
			
			JArrayHelper::toInteger($selectedFields);
		}
?>
			</tbody>
		</table>
		<?php if (count($selectedFields)): ?>
		<script>
		var selectedItems<?php echo $name; ?> = [<?php echo implode(',', $selectedFields); ?>];
		for (var i = 0; i < selectedItems<?php echo $name; ?>.length; i++) {
			for (var j = 0; j < fieldList<?php echo $name; ?>.options.length; j++) {
				if (selectedItems<?php echo $name; ?>[ i ] == fieldList<?php echo $name; ?>.options[ j ].value ) {
					fieldList<?php echo $name?>.options[ j ].selected = true;
					break;
				}
			}
		}	
		</script>
		<?php endif; ?>
		<script>
		makeOrderList<?php echo $name; ?>();
		</script>
		<?php
		$html = ob_get_contents();
		ob_end_clean();   
       		 
		return $html;
	}
}