<?php
/**
 * @fileID: $Id: noobslide.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
	
	JHTML::_('behavior.mootools');
	
	$document = & JFactory::getDocument();
	$document->addScript(JURI::root().'plugins/joomsuite_content_fields/galleryhelper.js');
	$document->addScript(JURI::root().'plugins/joomsuite_content_fields/_class.noobSlide.packed.js');
	
	// The noobslide skin parameters
	$skinParams = $params->get('skin', array());
	
	$thumb = new stdClass;
	$thumb->width = $params->get('thumb_width');
	$thumb->height = $params->get('thumb_height');
	$thumb->border = 10;
	
	$thumb->offsetWidth = $thumb->width + $thumb->border * 2;
	
	$big = new stdClass;
	
	$big->width = $params->get('max_width');
	$big->height = $params->get('max_height');
	$show_type_image = $params->get('show_filename_image');
	$show_type = $params->get('show_filename');
	if($show_type  || $show_type_image ){
		$offset = 40; 
	}else{
		$offset = 0;
	}
	
	// The gap between the thumb rows
	$gapSize = 20;
	
	$bgColor = $params->get('holder_bg', '#000000');
	
	$stretchThumbs = false;
	$autoPlay = true;
	
	/* The pictures URLs*/
	$pictures = $this->getFiles($data['files'], JURI::root() .$folder.'/'.$user.'/', $field->record_id, $params, $user, $field->id);

	$uid = uniqid('g_');
	
	$displayType 	= (int)$this->i($skinParams, 1, 0);
	$useShadowbox 	= $params->get('use_shadowbox', 1);
	
	$thumbsPerRow	= min((int)$this->i($skinParams, 2, 0), count($pictures));
	if ($thumbsPerRow <= 0)
		$thumbsPerRow = count($pictures);

	$handleEvent 	= $this->i($skinParams, 3, 'mouseenter');
	
	// Number of rows for thumbs to display
	$numRows = (int)($thumbsPerRow ? ceil(count($pictures) / $thumbsPerRow) : 1);
	if ($numRows <= 0)
		$numRows = 1;
	
	
	$transition = $this->i($skinParams, 4, 'Back');
	$transitionType = $this->i($skinParams, 5, 'easeOut');
	
	if ($transition != 'linear')
		$transition .= '.'.$transitionType;
	
	$transitionTime = (int)$this->i($skinParams, 6, 1000);
	
	$scriptDir = 'media/mightyextensions/js';
		
	if ($useShadowbox) {
		
		$document->addScript(JURI::root().$scriptDir.'/shadowbox/build/adapter/shadowbox-base.js');
		$document->addScript(JURI::root().$scriptDir.'/shadowbox/build/shadowbox.js"');
	}
	
	$showControls = in_array($displayType, array(0, 2));
	$showCarousel = in_array($displayType, array(0, 1, 3));
	$showBigPics = in_array($displayType, array(0, 1, 2));
	$showThumbs = $displayType == 3;
	$showCompact = in_array($displayType, array(4,5,6,7));
	
	$gallery_name = 'noob_gal_'.$uid.$field->id;
	
	$isAutoPlay = (int)$this->i($skinParams, 7, 1);
	
	$autoPlayInterval = (int)$this->i($skinParams, 8, 4000);
	
	$layout = $this->i($skinParams, 9, 0);
	$l = array('bottom', 'right', 'left', 'top');
	$lDesc = $l[ $layout ];
	
	
	// The height of gallery
	$galHeight = 0;
	
	if ($showBigPics)
		$galHeight += $big->height;
	if ($showCarousel) 
	{
		if ($lDesc == 'top' || $lDesc == 'bottom')
		$galHeight += $numRows * ($gapSize + $thumb->height) + 10;
	}
	if ($showControls)
		$galHeight += 20;
	
	$galWidth = $thumb->offsetWidth * $thumbsPerRow; 
	
//	echo '<pre>';
//	echo 'var_dump($showBigPics, $showCarousel, $showControls, $displayType);<br />';
//	var_dump($showBigPics, $showCarousel, $showControls, $displayType);
//	echo '</pre>';
	
	
	// Display only one picture. [modes 4,5,6,7]
	if ($displayType == 4 || $displayType == 5) {
		$idx = $displayType == 5 ? array_rand($pictures) : 0;
		if (isset($pictures[ $idx ]) && $pictures[ $idx ]->player == 'img') {
			$img = JHTML::image($pictures[ $idx ]->thumb, $pictures[ $idx ]->name, array('id' => $gallery_name));
			
			if ($useShadowbox)
				echo JHTML::link($pictures[ $idx ]->original, $img, array('rel' => 'shadowbox['.$gallery_name.'];player='.$pictures[ $idx ]->player.';'));
			else
				echo $img;
		}
	}	
	else if ($displayType == 6 || $displayType == 7) {
		$idx = $displayType == 7 ? array_rand($pictures) : 0;
		if (isset($pictures[ $idx ]) && $pictures[ $idx ]->player == 'img') {
			$img = JHTML::image($pictures[ $idx ]->bigthumb, $pictures[ $idx ]->name, array('id' => $gallery_name));
			
			if ($useShadowbox)
				echo JHTML::link($pictures[ $idx ]->original, $img, array('rel' => 'shadowbox['.$gallery_name.'];player='.$pictures[ $idx ]->player.';'));
			else
				echo $img;
		}
	}

	
	// Now, include the needed layout [bottom, right, left, top]
	$layoutCSS = JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'gallery2'.DS.'noobslide'.DS.$lDesc.'.php';
	
	if (! JFile::exists($layoutCSS)) {
		JError::raiseError('GN01', JText::_('Cannot find file'). ' : ' .$layoutCSS );
	}
	ob_start();
	include $layoutCSS;
	$document->addStyleDeclaration(ob_get_clean());
	
?>

	<script type="text/javascript">

	<?php if ($useShadowbox) : ?>
	Shadowbox.loadSkin('classic', '<?php echo JURI::root().$scriptDir ?>/shadowbox/build/skin');
	Shadowbox.loadLanguage('en', '<?php echo JURI::root().$scriptDir ?>/shadowbox/build/lang');
	Shadowbox.loadPlayer(['img', 'flv', 'qt', 'wmp'], '<?php echo JURI::root().$scriptDir ?>/shadowbox/build/player');
	
	window.addEvent('domready', function() {
        Shadowbox.init({
			overlayColor: '#123456',
			counterType: 5,
			counterLimit: 10,
			handleOversize: 'resize',
			gallery: '<?php echo $gallery_name; ?>',
			enableKeys: false
		});
		
		// Shadowbox.getOptions()['flvPlayer'] = '<?php echo JURI::root(); ?>components/com_resource/helpers/shadowbox2/flvplayer.swf';
		Shadowbox.getOptions()['flvPlayer'] = '<?php echo JURI::root(); ?>plugins/joomsuite_content_fields/media.swf';
	});
	<?php endif; ?>

	<?php if (!$showThumbs && ($showControls || $showCarousel || $showBigPics)) : ?>	
	window.addEvent('domready',function(){
		<?php if ($showCarousel) : ?>
		var theHandles = [];

		for (var i = 0; i < <?php echo $numRows; ?>; i++) {
			theHandles.extend($$('#handles<?php echo $uid; ?>_' + i + ' div'));
		}
		<?php endif; ?>
		var noobGal = new noobSlide({
			mode: 'horizontal',
			box: $('box<?php echo $uid; ?>'),
			items: [<?php echo implode(',', range(1, count($data['files']['name']))); ?>],
			size: <?php echo $big->width; ?>,
					
			<?php if ($showCarousel) : ?>
				handles: theHandles,
				handle_event: '<?php echo $handleEvent; ?>',
			<?php else : ?>
				handles: [],
			<?php endif; ?>
			<?php if ($isAutoPlay) : ?>
			interval: <?php echo $autoPlayInterval; ?>,
			<?php endif; ?>
			<?php if ($showControls) : ?>
				buttons: {
					previous: $('prev<?php echo $uid; ?>'),
					play: $('play<?php echo $uid; ?>'),
					stop: $('stop<?php echo $uid; ?>'),
					playback: $('playback<?php echo $uid; ?>'),
					next: $('next<?php echo $uid; ?>')
				},
			<?php endif; ?>
			
			button_event: 'click',
			fxOptions: {
				duration: <?php echo $transitionTime; ?>,
				transition: Fx.Transitions.<?php echo $transition; ?>, //Back.easeOut,
				wait: false
			},
			onWalk: function(currentItem,currentHandle){
				if(!window.ie){
					this.handles.each(function( e ) {
						e.setOpacity(0.3);
					});
					if (currentHandle)
						currentHandle.setOpacity(1);
				}
			}
		});
		noobGal.walk(<?php echo count($pictures) > 1 ? count($pictures) - 1 : 0; ?>, false, true);
		noobGal.next();

	});
	<?php endif; ?>
	</script>

<div id="gallery<?php echo $uid; ?>">
	<?php 
	if ($showBigPics) {
		echo '<div class="mask', $uid, '" id="mask', $uid, '">
		<ul style="list-style:none;" id="box', $uid, '">';
		foreach ($pictures as $p) {
			echo '<li style="float: left; padding: 0;margin:0;">';
			$img = '<div class="big_pic" style="height: '.$big->height.'; width: '.$big->width.';background: URL('.($p->bigthumb).') no-repeat; background-position: 50% 50%;" alt="'. 
			$p->name. '">&nbsp;</div>'; 
			if ( $show_type_image ){
				$img .='<div style="font-size: 80%;clear:both;">'.html_entity_decode($p->$show_type_image).'</div>';
			}
			if ($useShadowbox)
				echo JHTML::link($p->original, $img, array('rel' => 'shadowbox['.$gallery_name.'];player='.$p->player.';' , 'title' => JText::_('Click to enlarge')));
			else
				echo $img;
			echo'</li>';
		}
		echo '</ul>
		</div>';
	}
	else  // Create a dummy invisible DIV element, to pass to noobslide constructor as 'box' parameter.
		echo '<div style="display:none;" id="box', $uid, '"></div>';
?>

<!-- Thumbs-->
<?php if ($showCarousel) : ?>
	<div id="thumbs<?php echo $uid; ?>">
	<?php
		for($i = 0; $i < $numRows; $i++) :
	?>
		<div class="thumbs<?php echo $uid; ?>" id="handles<?php echo $uid; ?>_<?php echo $i; ?>">
		<?php
			$end = ($i + 1) * $thumbsPerRow;
			
			$w = min($thumb->width, $thumb->height);
			$paddingTop = ($thumb->height - $w) / 2;
			
			
			for ($j = $i * $thumbsPerRow; $j < $end; $j++) {
				if (!isset($pictures[ $j ]))
					break;
				if ($pictures[ $j ]->player != 'img')
					$img = '<div>'
						.JHTML::image($pictures[ $j ]->thumb, $pictures[ $j ]->name, array('style' => '"padding-top: '.$paddingTop.'px" width="'.$w.'px" height="'.$w.'px"'));
						
				else {
					$img = '<div><span '.($show_type ? 'title="'.html_entity_decode($pictures[ $j ]->$show_type) : '').'" style="display:block;height: '.$thumb->height.'; width: '.$thumb->width.';background: URL('. ($pictures[ $j ]->thumb).') no-repeat; background-position: 50% 50%;" alt="'. 
						$pictures[ $j ]->name. '" />&nbsp;</span>';
				}
				if ( $show_type ){
					$img .='<h4 align="center" style="font-size: 80%;">'.(mb_strlen(html_entity_decode($pictures[ $j ]->$show_type)) > 15 ? mb_substr(html_entity_decode($pictures[ $j ]->$show_type), 0, 15).'...' : html_entity_decode($pictures[ $j ]->$show_type)).'</h4></div>';
				}else{
					$img .= '</div>';
				}
				if (!$showBigPics && $useShadowbox)
					echo JHTML::link($pictures[ $j ]->original, $img, array('rel' => 'shadowbox['.$gallery_name.'];player='.$pictures[ $j ]->player.';'));
				else
					echo $img;
				echo "\n";
			}
		?>
		</div>
	<?php 	endfor; ?>
	</div>
<?php endif; ?>
<?php // Showing controls:
	if ($showControls) : 
?>
		<p id="buttons<?php echo $uid; ?>">
		<a id="prev<?php echo $uid; ?>"><?php echo htmlspecialchars(JText::_('<<Previous'), ENT_QUOTES, 'UTF-8'); ?></a>
		<a id="playback<?php echo $uid; ?>"><?php echo JText::_('Playback'); ?></a>
		<a id="stop<?php echo $uid; ?>"><?php echo JText::_('Stop'); ?></a>
		<a id="play<?php echo $uid; ?>"><?php echo JText::_('Play')?></a>
		<a id="next<?php echo $uid; ?>"><?php echo htmlspecialchars(JText::_('Next>>'), ENT_QUOTES, 'UTF-8'); ?></a>
	</p>
<?php endif; // showcontrols?>
 </div>
