<?php
/**
 * @fileID: $Id: right.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

$galWidth = 0;
if ($showCarousel)
	$galWidth += $thumb->offsetWidth * $thumbsPerRow;

$spaceBetweenThumbsAndBig = 20;

if ($showCarousel && $showBigPics)
	$galWidth += $spaceBetweenThumbsAndBig;

if ($showBigPics)
	$galWidth += $big->width;
	

// The height of gallery
$galHeight = 0;

$heightCaru = 0;
if ($showCarousel)
	$heightCaru = $numRows * ($gapSize + $thumb->height) + 10;

$heightBigWithControls = 0;

if ($showBigPics)
	$heightBigWithControls += $big->height;

if ($showControls)
	$heightBigWithControls += 20;

$galHeight = max($heightBigWithControls, $heightCaru);
	
/// Left position for thumbs ;)
$thumbsLeft = 0;

if ($showCarousel && $showBigPics)
	$thumbsLeft += $big->width + $spaceBetweenThumbsAndBig;

// Here we have the special positioning case: when the thumbnails are not shown, we need to center the big pic and control bar
$centerBigPic = false;
if ($showBigPics && !$showCarousel) 
{
	$centerBigPic = true;
	$bigPicsLeft = 50;
}

// Another case: display only the thumbs.
$centerThumbs = false;
if (!$showBigPics && $showCarousel)
{
	$centerThumbs = true;
}
?>
#gallery<?php echo $uid; ?> {
	position: relative;
	height: <?php echo $galHeight + $offset; ?>px;
	<?php if (!$centerBigPic && !$centerThumbs) : ?>
	width: <?php echo $galWidth; ?>px;
	<?php endif; ?>
}

<?php if ($showBigPics) : ?>
.mask<?php echo $uid; ?>{
	position:absolute;
	width:<?php echo $big->width; ?>px;
	height:<?php echo $big->height + $offset; ?>px;
	overflow:hidden;
	<?php if ($centerBigPic) : ?>
	left: 50%;
	margin-left: -<?php echo (int)($big->width / 2); ?>px;
	<?php endif; ?>
}

/* ********************************** */
#box<?php echo $uid; ?>{
	position:absolute;
	height:<?php echo $big->height; ?>px;
	width:<?php echo $big->width * count($pictures) * 3; ?>px;
	margin: 0;
	padding: 0;
	overflow: visible;
	background: <?php echo $bgColor; ?>;
}

#box<?php echo $uid; ?> div.big_pic {
	width: <?php echo $big->width; ?>px;
	height: <?php echo $big->height; ?>px;
	float: left;
	margin: 0;
	padding: 0;
	display:inline-block;
	border: 1px solid <?php echo $bgColor; ?>;
	border: none;
}

#box<?php echo $uid; ?> span {
	/* background: <?php echo $bgColor; ?>; */
	width: <?php echo $big->width; ?>px;
	height: <?php echo $big->height; ?>px;
	float: left;

	margin: 0;
	padding: 0;
	border: none;
}

#box<?php echo $uid; ?> span img{
	float: left;
	display:block;
	border:none;
}
<?php endif; ?>

<?php if ($showCarousel) : ?>

<?php for ($i = 0; $i < $numRows; $i++) : ?>
	#handles<?php echo $uid; ?>_<?php echo $i; ?>{
		<?php if ($i > 0) : ?>
		margin-top: <?php echo $gapSize; ?>px;
		<?php endif; ?>
		width: <?php echo $thumb->offsetWidth * $thumbsPerRow + 10; ?>px;
		height: <?php echo $thumb->height; ?>px;
		clear:both;
	}
<?php endfor; ?>
.thumbs<?php echo $uid; ?>{
	/* width:<?php echo $thumb->width; ?>px; */
}
.thumbs<?php echo $uid; ?> div{
	width:<?php echo $thumb->width; ?>px;
	height:<?php echo $thumb->height; ?>px;
	float: left;
	margin-left: <?php echo $thumb->border; ?>px;
	margin-right: <?php echo $thumb->border; ?>px;
	background: <?php echo $bgColor; ?>;
}
.thumbs<?php echo $uid; ?> span {
	width:<?php echo $thumb->width; ?>px;
	height:<?php echo $thumb->height; ?>px;
	<?php if ( ! (!$useShadowbox && $displayType == 3) ) : ?>
	cursor: pointer;
	<?php endif; ?>
	float: left;
}

.thumbs<?php echo $uid; ?> div img{
	display:block;
	border:none
	float:left;
}

#thumbs<?php echo $uid; ?> {
	clear: both;
	position: absolute;
	<?php if ($centerThumbs) : ?>
	left: 50%;
	margin-left: -<?php echo (int)($thumb->offsetWidth * $thumbsPerRow / 2 + 5); ?>px;
	<?php else: ?>
	width: <?php echo $thumb->offsetWidth * $thumbsPerRow + 10; ?>px;
	left: <?php echo $big->width + $spaceBetweenThumbsAndBig; ?>px;
	<?php endif; ?>
}
<?php endif; ?>

<?php if ($showControls) : ?>
#buttons<?php echo $uid; ?> {
	clear:both;
	text-align:center;
	padding-top: <?php echo $big->height + $offset; ?>px;
	margin: 0;
	<?php if (!$centerBigPic) : ?>
	width: <?php echo $big->width; ?>px;
	margin-left: <?php echo $bigPicsLeft; ?>px;
	<?php endif; ?>
}
#buttons<?php echo $uid; ?> a {
	cursor: pointer;
}
<?php endif; ?>