<?php
/**
 * @fileID: $Id: likedislike.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsLikeDislike extends JPlugin
{
	function plgJoomsuite_content_fieldsLikeDislike( &$subject, $params )
	{
	    //CREATE_TABLE
	    $sql= "CREATE TABLE IF NOT EXISTS `#__js_res_vote2` (
              `id` int(10) unsigned NOT NULL auto_increment,
              `user_id` int(10) unsigned NOT NULL default '0',
              `record_id` int(10) unsigned NOT NULL default '0',
              `field_id` int(10) unsigned NOT NULL default '0',
              `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
              `ip` varchar(16) NOT NULL default '',
              PRIMARY KEY  (`id`),
              KEY `record` (`record_id`),
              KEY `user` (`user_id`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	    
	    $db = &JFactory::getDBO();
	    
	    $db->setQuery($sql);
	    
	    if( $db->query() ){
	        
	        $filename = JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content_fields'.DS.'likedislike.php';
	        $f = JFile::read($filename);
	        
	        $start = strpos($f, '//CREATE_TABLE');
	        $end = strpos($f, '//'.'END_CREATE_TABLE');
	        
	        $content = substr_replace($f, '', $start, $end - $start);
	        JFile::write($filename, $content);
	    }
	    //END_CREATE_TABLE
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'likedislike') return;
        $user = &JFactory::getUser();
        if($user->gid > 19)
            $type = 'text';
        else
            $type = 'hidden';
		echo "<input type=\"{$type}\" name=\"fields[$obj->id]\" value=\"{$obj->field_value}\" />";
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'likedislike') return;
		if( !$value )
		    $value = '0:0';
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'likedislike') return;
		if(!$field->field_value) return;

		$db = &JFactory::getDBO();
		$user = &JFactory::getUser();
		$sql = "SELECT id FROM #__js_res_vote2 WHERE field_id={$field->fid} AND record_id = {$record->id} AND user_id={$user->id} AND ip ='{$_SERVER['REMOTE_ADDR']}' ";
		$db->setQuery($sql);
		$result = $db->loadResult();
		
		$params = new JParameter($field->params);
		$value = explode(':', $field->field_value);
		$pvalue = (int)$value[0];
		$nvalue = (int)$value[1];

		$doc = &JFactory::getDocument();
		$doc->addStyleSheet(JURI::root().'plugins/joomsuite_content_fields/likedislike.css');

		$out[] = '<div>';
		$out[] = '<div style="width:auto; float:left; vertical-align: middle;">';
		if( $params->get('text_class', 0) ){
		    $out[] = '<span class="'.$params->get('text_class').'" >';
		    $out[] = JText::_($params->get('text'));
		    $out[] = '</span>';
		}else
		    $out[] = JText::_($params->get('text'));
		    
		$out[] = ' :&nbsp;';
		$out[] = '</div>';
		if(!$result){
    		$out[] = '<div id="buttons">';
    		$out[] = '<button type="button"';
    		$out[] = ' onclick="xajax_jsCallPlugin(\'joomsuite_content_fields\', \'likedislike\', \'xajax_increment\', 
    					{value:\''.($pvalue+1).':'.$nvalue.'\', recordid:'.$record->id.', fieldid:'.$field->fid.', id:'.$field->id.'});"';
    		if( $params->get('pbutton_class',0) ){
    		    $out[] = ' class="'.$params->get('pbutton_class', 'button').'"';
    		}
    	    if( $params->get('pbutton_title',0) ){
    		    $out[] = ' title="'.JText::_($params->get('pbutton_title')).'"';
    		}
    		$out[] ='>';
    		
    		if( $params->get('pbutton_image') != -1 ){
    		    if( $params->get('pbutton_image_pos', 'left') == 'left' ){
    		        $out[] = '<img src="'.JURI::root().'images/'.$params->get('pbutton_image').'">';
    		        $out[] = JText::_($params->get('pbutton_text'));
    		    }else{
    		        $out[] = JText::_($params->get('pbutton_text'));
    		        $out[] = '<img src="'.JURI::root().'images/'.$params->get('pbutton_image').'">';
    		    }
    		    
    		}else
    		    $out[] = JText::_($params->get('pbutton_text'));
    		
    		$out[] = '</button>';
    		
    		if( $params->get('show_nbutton',0) ){
        		$out[] = '<button type="button"';
        		$out[] = ' onclick="xajax_jsCallPlugin(\'joomsuite_content_fields\', \'likedislike\', \'xajax_increment\', 
        					{value:\''.$pvalue.':'.($nvalue+1).'\', recordid:'.$record->id.', fieldid:'.$field->fid.', id:'.$field->id.'});"';
        		if( $params->get('nbutton_class',0) ){
        		    $out[] = ' class="'.$params->get('nbutton_class', 'button').'"';
        		}
        	    if( $params->get('nbutton_title',0) ){
        		    $out[] = ' title="'.JText::_($params->get('nbutton_title')).'"';
        		}
        		$out[] ='>';
        		if( $params->get('nbutton_image') != -1 ){
        		    if( $params->get('nbutton_image_pos', 'left') == 'left' ){
        		        $out[] = '<img src="'.JURI::root().'images/'.$params->get('nbutton_image').'">';
        		        $out[] = JText::_($params->get('nbutton_text'));
        		    }else{
        		        $out[] = JText::_($params->get('nbutton_text'));
        		        $out[] = '<img src="'.JURI::root().'images/'.$params->get('nbutton_image').'">';
        		    }
        		    
        		}else
        		    $out[] = JText::_($params->get('nbutton_text'));
        		    
    		    $out[] = '</button>';
    		}else{
    		    $doc->addStyleDeclaration('#like{ height: 15px;}');
    		}
    		
    		$out[] = '</div>';
		}
		
		if( $pvalue > 100 || $nvalue > 100){
    	    if( $pvalue > $nvalue ){
    	        $npvalue = 100;
    	        $nnvalue = 100 * $nvalue / $pvalue;
    	    } elseif ($pvalue < $nvalue){
    	        $nnvalue = 100;
    	        $npvalue = 100 * $pvalue / $nvalue;
    	    } else{
    	        $npvalue = 50;
    	        $nnvalue = 50;
    	    }
		}else{
		    $npvalue = $pvalue;
	        $nnvalue = $nvalue;
		}
	    
	    $out[] = '<div class="bars">
			<div id="like" style="width: '.$npvalue.'%;" class="likes-bar" title="'.$pvalue." - ".JText::_($params->get('pbutton_title')).'"></div>';
        if( $params->get('show_nbutton',0) ){
            $out[] =   '<div id="dislike" style="width: '.$nnvalue.'%;" class="dislikes-bar" title="'.$nvalue." - ".JText::_($params->get('nbutton_title')).'"></div>';
        }
		
        $out[] = '</div>';
		
		$out[] = '</div>';
		
		$out = implode('',$out);
	}
	
	function xajax_increment( &$response, $value, $recordid, $fieldid, $id) {
	    $params = ResHelper::getFieldParams($fieldid);
	    $db = &JFactory::getDBO();
	    $user = &JFactory::getUser();
	    $sql = "INSERT INTO #__js_res_vote2 VALUES (null,".$user->id.",".$recordid.",".$fieldid.",NOW(),'".$_SERVER['REMOTE_ADDR']."')";
	    $db->setQuery($sql);
	    $db->query();
	    $sql = "UPDATE #__js_res_record_values SET field_value = '{$value}' WHERE id = {$id} AND record_id = {$recordid}";
	    $db->setQuery($sql);
	    if( $db->query() ){
	        $values = explode(':', $value);
	        $response->script('
	        	$("like").setProperties({
	        		style: "width:'.$values[0].'%",
	        		title: "'.$values[0].' - '.$params->get('pbutton_title').'"
	    		});
	        	if( $("dislike") )
	        		$("dislike").setProperties({
    	        		style: "width:'.$values[1].'%",
    	        		title: "'.$values[1].' - '.$params->get('pbutton_title').'"
    	    		});
	        	$("buttons").remove();
	        ');
	    }else{
	        $response->assign('buttons', 'innerHTML', 'not submit!');
	    }
	    
	}
}