<?php
/**
 * @fileID: $Id: price_simple.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsPrice_simple extends JPlugin
{
	function plgJoomsuite_content_fieldsPrice_simple( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'price_simple') return;
		$unique_name =  $obj->id;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];
		?>
		<SCRIPT type="text/javascript">
				function pregmatch_<?php echo $unique_name ?>()
				{
					var currField = document.getElementById( 'fields<?php echo $obj->id; ?>').value;
					var reg1 = /[^0-9]+/;					
					var arrayTokens = currField.split( '.', 2 );					
					
					var part1 = '';										
					if( arrayTokens[ 0 ] ){
						part1 = arrayTokens[ 0 ];
						part1 = part1.replace(reg1, '');
					}
										
					var part2 = '';
					if( arrayTokens[ 1 ] ){				
						part2 = arrayTokens[ 1 ];
						part2 = part2.replace(reg1, '');
					}					
					
					var result = '';
					if( arrayTokens[ 0 ] && arrayTokens[ 1 ] )
						result = part1 + '.' + part2;					
					else if( arrayTokens[0] && !arrayTokens[ 1 ]){
						result = part1;
						if( currField.charAt( currField.length - 1 ) == '.' )
							result += '.'; 
					}else if( arrayTokens[1] ){
						result = part2;
					}
					
					document.getElementById('fields<?php echo $obj->id; ?>').value = result;									    				    
				} 
			</SCRIPT>
		<?php
		echo "<span>".$params->get('sign_before')."</span>";
		$pregmatch = "onkeyup='pregmatch_$unique_name()'";
		?>			
			<input type="text" <?php echo $pregmatch ?> id="fields<?php echo $obj->id?>" <?php echo ((int)$params->get('maxlen')) ? 'maxlength="'. (int)$params->get('maxlen') .'"' : ''; ?> style="width:<?php echo $params->get('field_size')?>" name="fields[<?php echo $obj->id?>]" value='<?php echo htmlspecialchars(stripslashes($obj->field_value), ENT_QUOTES, 'UTF-8'  ); ?>'/>
		<?php
		echo "<span>".$params->get('sign_after')."</span>";
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'price_simple') return;
		if(!$value) return;

		$pregmatch = $params->get('pregmatch');
		$pattern = '';
		$parts = explode('.', $value, 2);
		$part1 = $parts[ 0 ];

		if( $part1 == '' || !$part1 ) $part1 = "0";

		$pattern = "/[^0-9]/i";
		$part1 = preg_replace($pattern, '', $part1);

		$part2 = ( @$parts[1] ) ? $parts[1] : '';
		if( $part2 != '' ){
			$part2 = preg_replace($pattern, '', $part2);
		}
		settype($part1, "string");
		settype($part2, "string");
		$result = $part1;
		$result .= ( $part2 ) ? ".".$part2 : '';
		$value = $result;					

		$db = &JFactory::getDBO();
		$value = $db->getEscaped( trim($value) );

		#echo $value;
		#die;
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'price_simple') return;
		if( !$field->field_value ) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	
		$all = $field->field_value;

		$field->field_value = stripslashes( $field->field_value );
		$field->field_value = htmlspecialchars($field->field_value, ENT_QUOTES, 'UTF-8');
		$params->set('category_id', $category);
		$field->field_value = ResHelper::cleanFilterValue($field->field_value, base64_encode($all), $field, $params, $record);
		
		$vals = $params->get('vals', 2);
		!isset($vals)? $vals = 0: null;
		$dec = $params->get('dec', '.');
		$dec == 'ws'? $dec = ' ': null;
		$thous = $params->get('thous', ',');
		$thous == 'ws'? $thous = ' ': null;
		
		$formatted = number_format($field->field_value, $vals, $dec, $thous);
		
		$out = trim(stripslashes( $params->get('sign_before').$formatted.$params->get('sign_after')));
		//if you need convirt price to another currency
		if($rate = $params->get('conv_rate', 0)){
			$rated = $field->field_value*$rate;
			$formatted = number_format($rated, $vals, $dec, $thous);
			$params->get('show_rate', 0)? $rate = '1:'.$rate: $rate = null;
			$out .= " ".trim(stripslashes( $params->get('conv_sign_before', '(').$formatted.$params->get('conv_sign_after', ')'))).$rate;
		}
	}

	//function onRenderFilter($get, &$filter, $fparam, $filters_type /*, $user*/)
	function onFilter($out, $type)
	{
		if($type != 'price_simple') return;
		$out = true;
	}
	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;

		if($filters_type != 'price_simple') return;

		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$db = & JFactory::getDBO();
		
		$where = getFilterWhere($params);

		switch ($params->get('filters_mode', 1))
		{
			case 1:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid = {$category} {$where}
				GROUP BY fv.field_value";
				break;
			case 3:
				$category = JRequest::getInt('category_id', $category);
				$ids = ResHelper::getCategoryChildrenIds($category);
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid IN ({$ids}) {$where}
				GROUP BY fv.field_value";
				break;
				
			case 2:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				WHERE fv.field_id = {$filter->id} {$where}
				GROUP BY fv.field_value";
				break;
		}

		if($fparam->get('order_by')) $sql .= ' ORDER BY ' . $fparam->get('order_by');

		//echo $sql;
		if(!key_exists($sql, $results))
		{
			//echo 123;
			$db->setQuery($sql);
			$get = $db->loadObjectList();
			$results[$sql] = $get;
		}
		else
		{
			$get = $results[$sql];
		}

		if(is_array($get))
		{
			foreach ($get AS $key => $val)
			{
				$get[$key]->value = base64_encode($val->value);
			}
		}
		//echo $filter->title;
		//print_r($get);
	}
}
?>