<?php
/**
 * @fileID: $Id: relate_child3.php 7800 2012-02-13 07:01:36Z kostya $
 * @changedDate: $LastChangedDate: 2012-02-13 14:01:36 +0700 (Пн, 13 фев 2012) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsRelate_child3 extends JPlugin
{
	function plgJoomsuite_content_fieldsRelate_child3( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper3.php';
		JHTML::_('behavior.modal');
	}
	
	function trimArray($def)
	{
		//$def = JArrayHelper::toInteger($def);
		settype($def, 'array'); $out = array();
		foreach($def as $id)
		{
			if((int)$id <= 0) continue;
			$out[] = $id;
		}
		return $out;
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'relate_child3') return;

		if( !$params->get('parent_type') || !$params->get('parent_section') ) {
			echo JText::_( 'This field is not configured. Please set parent type and parent section in params of this field' );
			return;
		}
		
		if($parent = JRequest::getString('related'))
		{
			$def[] = $parent;
		}
		else
		{
			$def = JRequest::getVar('fields', array(), 'default', 'array');
			if(key_exists($obj->id, $def)) {
				$def = $def[$obj->id];
			}
			else
			{
				$def = explode(',', trim($obj->field_value));
			}
			settype($def, 'array');
			$def = $this->trimArray($def); 
		}
		$link = '';
		$app = JFactory::getApplication();
		if( $app->isAdmin()){
			$link .= '../';
		}
		$link .= 'index2.php?option=com_resource&view=utility&layout=relation&article='.$obj->record_id.'&field='.$obj->id./*'&category='.$params->get('parent_section').*/'&format=html';
		$link = MERoute::_($link);
		echo "<span class=\"readonbox\">".
		//<a class=\"readon relate_child3_add_existing{$obj->id}\" rel=".$obj->record_id.'::'.$obj->id." href=\"".$link."\">"
		"<a class=\"modal readon _child3_add_existing{$obj->id}\" onclick=\"$('relatedItems{$obj->id}').empty()\" rel=\"{handler: 'iframe', size: {x: 800, y: 600}}\" href=\"".$link."\">"
			.JText::_($params->get('add_existing_label', 'Attach Existing'))
			."</a></span>";
		echo '<div style="clear:both;height:5px"></div>';
		echo '<div id="relatedItems', $obj->id, '">', 
			( ! $def) ? JText::_('No items selected') : '', 
			'</div><div style="clear:both"></div>';
		
		JHTML::_('behavior.modal');
		$document = & JFactory::getDocument();
			
		
		$document->addScriptDeclaration("if (!window.relatedChildFunctions)	window.relatedChildFunctions = {};");
		
		
		/// Generic function gateway
		$document->addScriptDeclaration(
			"function onRelatedArticlesSelected(articleId, fieldId, relatedIds, titles, params) {
				if (!relatedIds) return;
				window['relatedChildFunctions_' + fieldId](articleId, fieldId, relatedIds, titles, params);
			}"
		);
		
		$document->addScriptDeclaration(
			"
			function relatedChildFunctions_{$obj->id}(articleId, fieldId, relatedIds, titles, params) 
			{
				for (var i = 0; i < relatedIds.length; i++) {
					var outer = new Element('div');
					outer.setStyle('float', 'left').addClass('article_selector_span').setHTML(titles['article' + relatedIds[ i ]]);
					var input = new Element('input');
					input.setProperties({'name':'fields[$obj->id][vals][]', 'type':'hidden', 'value':relatedIds[i]}).inject(outer);
					var div = new Element('div');
					if(typeof(params['article' + relatedIds[ i ]]) != 'undefined'){
						var hparams = new Element('input');
						hparams.setProperties({'name':'fields[$obj->id][params][' + relatedIds[i] + ']', 'type':'text', 'value':params['article' + relatedIds[ i ]]}).addClass('inputbox').inject(div);
					}
					var a = new Element('a', {href: 'javascript:void(0);'}).setHTML('".addslashes(JHTML::image(JURI::root().'components/com_resource/images/f-c2.png', JText::_('Remove', true)))."').inject(outer);
					a.addEvent('click', function() {
						this.getParent().remove();
					});
					outer.inject($('relatedItems$obj->id'));
					div.inject(outer);
				}
			}"
		);
		
		if ($def) {
			$ids = implode(', ', $def);
			$db = &JFactory::getDBO();
			$db->setQuery('SELECT id, title FROM #__js_res_record WHERE id IN ('.$ids.')');
			$titles = $db->loadObjectList('id');
			$obj->fparams? $fparams = unserialize($obj->fparams): $fparams = array();
			
			$t = array();
			$p = array();
			foreach ($def as $id) {
				if (!empty($titles[ $id ]))
					$t [] = '"article'.$id.'": "'.addslashes($titles[ $id ]->title).'"';
				if($params->get('relate_tags', 1))
				{
					isset($fparams[ $id ])? $fparam = addslashes($fparams[ $id ]): $fparam='';
					$p [] = '"article'.$id.'": "'.$fparam.'"';
				}
			}
			
			$t = '{'.implode(', ', $t).'}';
			$p = '{'.implode(', ', $p).'}';
			$document->addScriptDeclaration(
				"window.addEvent('domready', function() {
					relatedChildFunctions_{$obj->id}($obj->record_id, $obj->id, [$ids], $t, $p);
				});"
			);
		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'relate_child3') return;
		$db = & JFactory::getDBO();
		$user = &JFactory::getUser();

		settype($value['vals'], 'array');
		settype($value['params'], 'array');
		JArrayHelper::toInteger($value['vals']);
		JArrayHelper::toString($value['params']);
		$vals = $this->trimArray($value['vals']);
		$vals = array_unique($vals);
		$pars = array_unique($value['params']);

		if ($params->get('required_relate') && !count($value)) {
			$error = true;
			JError::raiseWarning(400, JText::_('Parent article is not selected'));
			return;
		}
		$value = ','.implode(',', $vals).',';
		return $pars;
	}
	
	function onFilter($out, $type)
	{
		if($type != 'relate_child3') return;
		$out = true;
	}
	
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		if($type->type != 'relate_child3') return;
		if(!$value) return;
		
		$sql = "field_value LIKE '%,{$value},%'";
	}
	
	function onFilterWornLabel(&$label, &$filter, $value, &$params, $category_id)
	{
		if($filter->type != 'relate_child3') return;
		$value = (int)$value;
		if(!$value) return; 
			
		$record = & JTable::getInstance('Record', 'Res');
		if($record->load($value)) 
		{
			$label = $record->title;
		}
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'relate_child3') return;
		if(!$field->field_value) return;
		global $mainframe;
		$controls = array();

		$db			= &JFactory::getDBO();
		$user 	= & JFactory::getUser();
		$params 	= new JParameter($field->params);
		$list_params = ResHelper::initListParams($category);
		
		$ids = explode(',', $field->field_value);
		$ids = $this->trimArray($ids);
		
		$aid = JRequest::getInt('relatedArticle');
		$fid = JRequest::getInt('relatedField');
		$iid = explode(',',JRequest::getvar('relatedIds'));
		$param_vals = explode(',', JRequest::getVar('paramVals'));
		if($aid == $record->id && $fid == $field->fid )
		{
//			settype($iid, 'array');
//			foreach ($iid AS $id)
//			{
//				$ids[] = $id;
//			}
			$iid = array_unique($iid);
			$iid = $this->trimArray($iid);
			settype($param_vals, 'array');
			$param_vals = array_combine($iid, $param_vals);
			$sql = "UPDATE #__js_res_record_values SET field_value = ',".implode(',', $iid).",', params = '".serialize($param_vals)."' WHERE id = ".$field->id;
			$db->setQuery($sql);
			$db->query();
			if(empty($iid)){
				$ids = false;	
			}else{
				$ids = $iid;
			}
			$mainframe->enqueueMessage(JText::_('Attachment Successfull'));
		}
		//var_dump($ids,empty($iid));exit;
		if($ids)
		{
			if(JRequest::getVar('view') == 'list' || $params->get('fullviewlisttype') == 'titles')
			{
				$sql = "SELECT * FROM #__js_res_record WHERE id IN(".implode(',', $ids).") ORDER BY ".$params->get('intro_orderby', 'ctime DESC')." LIMIT ".$params->get('limit_intro');
				$db->setQuery($sql);
				$records = $db->loadObjectList();
				
				$params->set('filter_linkage', 2);
				$params->set('category_id', $category);
				
				$li = array(); $i = 0;		
				foreach ($records AS $item)
				{
					$li[$i]->id = $item->id;
					$li[$i]->link = ResHelper::cleanFilterValue(
						JHTML::link(
							MEUrl::link_record(
								$item, 
								$params->get('parent_section')
							), 
							$item->title
						), 
						base64_encode($item->id), 
						$field, 
						$params,
						$record
					);
					$i++;
				}
				
				$helper = FieldRelateHelper::getInstance();
				
				$helper->set('isParent', 		false);
    			$helper->set('childFieldId', 	$field->fid);
    			$helper->set('childRecordId', 	$field->record_id); 
    			$helper->set('parentType', 		$params->get('parent_type'));
    			
				if(count($li) <= 0 )
					$out = JText::_('No items');
				else
					$out = $helper->getDecoratedList($li, $params);;
			}
			else 
			{
				require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php';
	
				$options = array();
				$options['limit'] 		= $params->get('limit_full');
				$options['category'] 	= $params->get('parent_section');
				$options['user_id'] 	= 0;
				$options['view_what'] 	= 0;
				$options['client'] 		= 'module';
				if ($params->get('relate_tags', 0)) 
					$options['relate_tags'] 		= $field->vparams;
				$options['records_mode'] = 2;
				if ($params->get('full_template')) 
					$options['template'] = $params->get('full_template');
				if ($params->get('full_orderby')) 
					$options['order'] = $params->get('full_orderby', 'r.title ASC');
					
				$where = array('r.id IN ('.implode(',', $ids).')');
				$join = array();
	
				$a = null;
				$b = null;
				
				$list = MightyResourcesApi::getRecordList($options, $where, $join, $a, $b);
				
				if (count($list[0]) <= 0 )
					$out = JText::_('No items');
				else
					$out = $list[1];
			}
			
			if(((JRequest::getInt('article')) && $params->get('full_show_readmore') && ($params->get('limit_full') < count($ids))) || ((JRequest::getVar('view') == 'list') && $params->get('intro_show_readmore') && ($params->get('limit_intro') < count($ids))))
			{
				$readMoreType = JRequest::getVar('view') == 'list' ? $params->get('intro_show_readmore') : $params->get('full_show_readmore');
				$link = '';
				switch ($readMoreType)
				{
					case 2: // Filter
						$q = 'select f.id, f.params, f.title FROM #__js_res_fields f WHERE f.`type` = "relate_parent3" AND LOCATE("relate_field='.$field->fid.'", f.params)';
						$db->setQuery($q, 0, 1);
						$parent_field = $db->loadObject();
						
						if ($parent_field)
						{
							$pf_params = new JParameter($parent_field->params);
							if($pf_params->get('filter_enable'))
							{
								$filter = '&filter'.$parent_field->id.'[]='.base64_encode($record->id);
								$link = MEUrl::link_list($params->get('parent_section'));
								$link = MERoute::_($link.$filter);
							}
							else
							{
								JError::raiseNotice(1010, JText::_('Error: Cannot create "Show All..." link. Related field have not been set as filter').' ['.JText::_('Field').': '.$parent_field->title.' ('.$parent_field->id.')]');
							}
						}
					break;
					
					case 1:
						$link = MEUrl::link_list($params->get('parent_section'), array('view_what' => 'related'));
						$link = MERoute::_($link.'&child='.$record->id.'&field='.$field->fid);
					break;
				}
				if($link) $controls[] .= " <span class=\"readonbox\"><a class=\"readon\" href=\"{$link}\">".JText::_($params->get('invite_view_more', "Show All..." ))." (".count($ids).")</a></span> ";
			}
		}
		
		// add new parent link
		if($user->get('aid') >= $params->get('add_more_access') || MEAccess::isAdmin() || MEAccess::isAuthor($record->user_id, ($params->get('add_more_access') == 5) ))
		{
			$link = 'index.php?option=com_resource&controller=article'
				.'&type_id='.$params->get('parent_type').'&child_id='.$field->id
				.'&view=article&layout=form&related='.$record->id;
			
			
			$forcedCategory = $params->get('force_category');
			settype($forcedCategory, 'array');
			if(@$forcedCategory[0])
			{
				$link .= '&category_id='.$forcedCategory[0];
				$forcedCategory = implode(',', $forcedCategory);
				if($forcedCategory) $link .= '&hc='.base64_encode($forcedCategory);
			}
			else
			{
				$link .= '&category_id='.$params->get('parent_section');
			}
			
			$link .= '&Itemid='.MEUrl::itemid(null, $params->get('parent_section'));
			
			$uri = JFactory::getURI();
			$oldFid = $uri->setVar('child_id', $field->fid);
			$uri->delVar('lastid');
			$url = $uri->toString();
			$link .= '&redirect='.base64_encode($url);
			
			$controls[] = " <span class=\"readonbox\"><a class=\"readon\" href=\"".MERoute::_($link)."\">".JText::_($params->get('invite_add_more', "Add New"))."</a></span> ";
		}
		
		if ($params->get('strict_to_user'))
		{
			$strictToUser 	= $params->get('strict_to_user', array());
			settype($strictToUser, 'array');
			
			if ( in_array($user->get('gid'), $strictToUser) ){
				if ( $record->user_id == $user->get('id') )
					$strictToUser = true;
				else
					$strictToUser = false;
			} else {
				$strictToUser = true; 
			}
			
			// Superadmins don't have strict to user mode
			if ($user->get('gid') == 25)
				$strictToUser = true;
		}
		else
		{
			$strictToUser = true;
		}
				
		if(($user->get('aid') >= $params->get('add_existing') || MEAccess::isAdmin()) && $strictToUser == true )
		{
			$link = '';
			$app = JFactory::getApplication();
			if( $app->isAdmin()){
				$link .= '../';
			}
			$link .= 'index2.php?option=com_resource&view=utility&layout=relation&article='.$record->id.'&field='.$field->fid.'&format=html';
			if ($category != $params->get('parent_section'))
				$link .= '&category='.$params->get('parent_section');
				
			$link = MERoute::_($link);
			
			$controls[] = "<div class=\"readonbox\">".
				//"<a class=\"readon relate_child3_add_existing{$field->fid}\" rel=".$record->id.'::'.$field->fid." href=\"".$link."\">"
				"<a class=\"modal readon\" rel=\"{handler: 'iframe', size: {x: 800, y: 600}}\" href=\"".$link."\">"
				.JText::_($params->get('add_existing_label', 'Attach Existing'))
				."</a></div>";
		}
		JHTML::_('behavior.modal');
		
		$uri = JFactory::getURI();
		
		$document = & JFactory::getDocument();
		/*$document->addScriptDeclaration(
			"window.addEvent('domready', function() {
				$$('a.relate_child3_add_existing{$field->fid}').each(function( i ) {
					if (i.rel) {
						var parts = i.rel.split('::');
						if (parts.length != 2) 
							return;
						
						var rid = parseInt(parts[ 0 ]);
						var fid = parseInt(parts[ 1 ]);
						i.addEvent('click', function( e ) {
							if( window.ie ){
								e.returnValue = false;
							}else{
								e.preventDefault();
								e.stopPropagation();
							}
							
							var href = i.getAttribute('href');
							
							i.setAttribute('rel', '{handler: \'iframe\', size: {x: 800, y: 600}}');
							i.setAttribute('href', href + '&tmpl=component');
							
							SqueezeBox.fromElement( i );
							i.setAttribute('rel', parts.join('::'));
							i.setAttribute('href', href);
						});
					}
				});
			});
			
			"
		);*/
		$document->addScriptDeclaration(
			'function onRelatedArticlesSelected(articleId, fieldId, relatedIds, titles, params) {
				if ( ! relatedIds )
					return;
				
				var url = \''.addslashes($uri->toString()).'\';
				
				var form = new Element(\'form\', {action: url, method: \'post\'});
				
				new Element(\'input\', {name: \'relatedArticle\', type: \'hidden\', value: articleId}).inject(form);
				new Element(\'input\', {name: \'relatedField\', type: \'hidden\', value: fieldId}).inject(form);
				new Element(\'input\', {name: \'relatedIds\', type: \'hidden\', value: relatedIds.join(\',\')}).inject(form);
				var paramVals = [];
				$each(params, function(el){
					paramVals.push(el);
				});
				if(paramVals.length)
					new Element(\'input\', {name: \'paramVals\', type: \'hidden\', value: paramVals.join(\',\')}).inject(form);
				document.body.appendChild(form);
				form.submit();
			}'
		);
		$out .= implode(' ', $controls);
		return;
		
	}
	
	function onXajaxDeleteArticleRelation(&$response, $childFieldId, $childRecordId, $parentType, $parentRecordId, $callback)  {
		
		$db = & JFactory::getDBO();
		//$response->alert($parentRecordId);
		
		$sql = "SELECT field_value FROM #__js_res_record_values WHERE record_id = $childRecordId AND field_id = $childFieldId";
		$db->setQuery($sql);
		$result = explode(',', $db->loadResult());
		$result = self::trimArray($result);
		JArrayHelper::toInteger($result);
		unset($result[array_search($parentRecordId, $result)]);
		
		$sql = "UPDATE  #__js_res_record_values SET field_value = ',".implode(',', $result).",' WHERE record_id = $childRecordId AND field_id = $childFieldId";
		$db->setQuery($sql);
		$db->query();
		
		$response->script($callback);
	}
}