<?php
/**
 * @fileID: $Id: default.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die('Restricted access'); 

// Show the child list.
//echo '<pre>';
//var_dump($relatedFields, $relatedRecords);
//die;

$li_class = $this->get('relatedRecordCssClass');

echo '<ul>';
foreach ( $relatedRecords as $record )
{	
	$recordId = $record->id;
	
	$fields = isset($relatedFields[$record->id]) ? $relatedFields[$record->id] : null;
	
	$hasFields 	= is_array($fields) && count($fields);
	$title 		= $hasFields && $params->get('value_as_link', 0) ? $record->title : $record->ntitle;
		
	echo '<li class="', $li_class, '" rel="', $record->id, '">';
	if ($params->get( 'show_article_title', 1 )) {
		echo $title;
	}
	
	$this->includeEventsJavascript($params, $record);
	
	// "Edit | Remove from list" controls
	$controlButtons = $this->getControlButtons($record, $params);
	if ($controlButtons)
		echo $controlButtons;
	
	if ($params->get( 'show_article_title', 1 ))
		echo '<br />';
	
	if ($hasFields) 
	{
		foreach ($fields as $f) {
			//echo '<b>', $f['field']->title, ': </b>';
			if ($params->get('value_as_link', 0))
				echo '<a href="'.$record->link.'">'.$f['text'].'</a><br />';
			else
				echo $f['text'].'<br />';
		}
	}
	echo '</li>';
}

echo '</ul>';
?>
