<?php
/**
 * @fileID: $Id: select_relate.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsSelect_relate extends JPlugin
{
	function plgJoomsuite_content_fieldsSelect_relate( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function xajax_expandChild( $objResponse, $field_id, $super_parent, $value )
	{
		$super_parent = $super_parent === "null" ? null : (int)$super_parent;
		
		$db = JFactory::getDBO();
		 
		$db->setQuery( "SELECT params FROM #__js_res_fields where id = ".$field_id );
		$ini_params = $db->loadResult();
		 
		$params = new JParameter( $ini_params );
		 
		$dump_values = $this->parseValues( $params->get( "values" ) );
		 
		$parent_values = $this->getValuesByParent( $dump_values, $super_parent );
		 
		$parent = $this->findNewParent( $parent_values, $dump_values, $value );
		 
		$level_key = isset( $dump_values[ $super_parent ] ) ? ( $dump_values[ $super_parent ]["level"] + 2 ) : 2;
		 
		$level_labels = $this->prepareLines( $params->get( "level_labels" ) );
		
		$html = "";

		if( $parent !== null ) {
			if( $params->get( "max_level" ) != "-1" &&  $dump_values[$parent]["level"] == $params->get( "max_level" ) ) {
				$objResponse->assign( "sr_span_".$field_id."_".$level_key, "innerHTML", "" );
				return;
			}
				
			$new_values = $this->getValuesByParent( $dump_values, $parent );

			$event = "onchange=\"JSexpandChild".$field_id."( ".( is_null( $parent ) ? "'null'" : $parent ).", this.value, ".$level_key." );\"";
				
		    $user_variant = false;
            if( $params->get( "user_value" ) && $params->get( "min_user_value_level" ) <= $level_key ) {
              $user_variant = true;
            }
			
			if( count( $new_values ) ) {
				$options = $this->generateOptions( $new_values, $dump_values, $params->get( "sort" ), $params->get( "max_level" ), $user_variant, $params );
					
				$html = $this->renderList( $field_id, $parent, $level_key, "", $options, $params,  $user_variant, $level_labels );

				$html .= '<span id="sr_span_'.$field_id.'_'.( $level_key + 1 ).'">'
				.'</span>';
			} else {
				if( $value && $params->get( "min_user_value_level" ) <= $level_key && $params->get( "user_value" ) && ( $level_key <= $params->get( "max_level" ) || $params->get( "max_level" ) == "-1" ) ) {
					//$html .= '<a href="javascript:JSnewTextField'.$field_id.'( '.( $level_key ).', 0 )">'.$params->get( "user_value_label" ).'</a>';
					
					$onblur = "onblur='JStextFieldHider".$field_id."( this.value, ".( $level_key + 1 )." )'";
					$onkeyup = "onkeyup='JStextFieldShower".$field_id."( this.value, ".( $level_key + 1 )." )'";
					
					$img_onclick = 'onclick="JStextFieldHider'.$field_id.'( \'\', '.( $level_key + 1 ).' )"';
				    if( count( $level_labels ) ) {
		                $level_label = ( isset( $level_labels[$level_key - 1] ) ? $level_labels[$level_key - 1] : "" ).'<br>';
		            } else {
		                $level_label = "";
		            }
					
				    if( ( $level_key ) > 1 ) {
                        $html .= '<span class="sr_arrow_img" style="background:url( '.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/arrow.png ) no-repeat right 50%;"> '.( count( $level_labels ) ? "<br>" : "" ).'<span style="visibility:hidden">.</span> </span>';
                    }
		            
					$html .= '<span class="sr_border">'.
					             $level_label.
					             "<input type='text' name='fields[".$field_id."][uservalue][".( $level_key - 1 )."]' ".$onblur." ".$onkeyup.">". 
					             '<img src="'.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/delete.png" class="sr_delete_img" '.$img_onclick.'/>'.
                                 "<input type='hidden' value='text' name='fields[".$field_id."][uservalue_switch][".( $level_key - 1 )."]' id='fields".$field_id."_uservalue_switch_".($level_key)."'>".
                             "</span>".
                             "<span id='sr_span_".$field_id."_".($level_key + 1)."'></span>";
				}
			}
				
		}
		 
		$objResponse->assign( "sr_span_".$field_id."_".$level_key, "innerHTML", $html );
	}

	function prepareLines( $text )
	{
		if( !is_array( $text ) ) {
	      $lines = explode( "\n", $text );
		} else {
		  $lines = $text;
		}
		
		$prepared_lines = array();
		
	    foreach( $lines as $key => $v ) {
            if( !trim ( $v ) ) continue;
            $prepared_lines[] = $v;
        }
        
		return $prepared_lines;
	}
	
	function onRenderField( &$obj, &$params, $type )
	{
		if( $type != 'select_relate' ) return;
        
		$document = & JFactory::getDocument();
		$document->addStyleSheet( JURI::root().'plugins/joomsuite_content_fields/select_relate.css' );
		
		$dump_values = $this->parseValues( $params->get( "values" ) );

		if( $obj->field_value ) {
			$current_values = explode( "\n", $obj->field_value );
		} else {
			$current_values = $this->prepareLines( $params->get( "selected" ) );
			foreach( $current_values as $key => $v ) {
				preg_match( "/^([> ]*)(.*)$/", $v, $matches );
				$current_values[$key] = $matches[2];
			}
		}

		$current_values = $this->prepareLines( $current_values );
        
		if( ! count( $current_values ) || $current_values[0] ) {
			$current_values[] = "";
		}

		$level_labels = $this->prepareLines( $params->get( "level_labels" ) );
		
		$parent = null;
		
		$opened_spans = 0;
        
		$key = 0;
		
		foreach( $current_values as $key_ => $current_value ) {


			$part_of_values = $this->getValuesByParent( $dump_values, $parent );

			//if( !count( $part_of_values ) ) break;

			if( $params->get( "max_level" ) != "-1" && $key + 1 > $params->get( "max_level" ) ) break;

			$user_variant = false;
			if( $params->get( "user_value" ) && $params->get( "min_user_value_level" ) <= $key +1 ) {
			  $user_variant = true;
			}
			
			$options = $this->generateOptions( $part_of_values, $dump_values, $params->get( "sort" ), $params->get( "max_level" ), $user_variant, $params );
			echo '<span id="sr_span_'.$obj->id.'_'.($key + 1).'">';

			echo $this->renderList( $obj->id, $parent, $key +1, $current_value, $options, $params, $user_variant, $level_labels );

			$parent = $this->findNewParent( $part_of_values, $dump_values, $current_value );

			$last_value = $current_value;

			$opened_spans ++;
			$key ++;
		}
		$key --;
		
		echo '<span id="sr_span_'.$obj->id.'_'.($key + 2).'">';
		if( $last_value && $params->get( "min_user_value_level" ) <= $key + 1 && $params->get( "user_value" )&& ( $key + 2 <= $params->get( "max_level" )  || $params->get( "max_level" ) == "-1" ) ) {
			
			//echo '<a href="javascript:JSnewTextField'.$obj->id.'( '.( $key + 1 ).', 0 )">'.$params->get( "user_value_label" ).'</a>';
			
			$onblur = "onblur='JStextFieldHider".$obj->id."( this.value, ".( $key + 3 )." )'";
			$onkeyup = "onkeyup='JStextFieldShower".$obj->id."( this.value, ".( $key + 3 )." )'";
			
			$img_onclick = 'onclick="JStextFieldHider'.$obj->id.'( \'\', '.( $key + 3 ).' )"';
        	
			if( count( $level_labels ) ) {
	          $level_label = ( isset( $level_labels[$key + 1] ) ? $level_labels[$key + 1] : "" ).'<br>';
	        } else {
			  $level_label = "";
	        } 
	        
		    if( ( $key+1 ) > 1 ) {
                echo '<span class="sr_arrow_img" style="background:url( '.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/arrow.png ) no-repeat right 50%;"> '.( count( $level_labels ) ? "<br>" : "" ).'<span style="visibility:hidden">.</span> </span>';
            }
	        
			echo '<span class="sr_border">'.
					 $level_label.
			         "<input type='text' name='fields[".$obj->id."][uservalue][".( $key+1 )."]' ".$onblur." ".$onkeyup.">".
			         '<img src="'.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/delete.png" class="sr_delete_img" '.$img_onclick.'/>'.
                     "<input type='hidden' value='text' name='fields[".$obj->id."][uservalue_switch][".( $key +1 )."]' id='fields".$obj->id."_uservalue_switch_".($key + 1)."'>".
			     "</span>".
			     "<span id='sr_span_".$obj->id."_".($key + 3)."'>".
                 "</span>";
		}
		echo '</span>';

		echo str_repeat( "</span>", $opened_spans );

		?>
        <script type="text/javascript">
		  function JSexpandChild<?php echo $obj->id; ?>( parent, value, level )
		  {
		    var child_span = document.getElementById( 'sr_span_<?php echo $obj->id; ?>_' + ( level + 1 ) );
		   
		    var current_field = document.getElementById( "fields<?php echo $obj->id; ?>_" + level );
		    
		    if( current_field.options.length - 1 == current_field.options.selectedIndex
		        && <?php echo $params->get( "user_value" ) ? "true" : "false"; ?>
		        && <?php echo $params->get( "min_user_value_level" ); ?> <= level ) {
		        document.getElementById( 'fields<?php echo $obj->id; ?>_spanlist_' + level ).style.display = "none";
                document.getElementById( 'fields<?php echo $obj->id; ?>_spantext_' + level ).style.display = "inline";
                
		        document.getElementById( "fields<?php echo $obj->id; ?>_uservalue_switch_" + level ).value = "text";
		        
		        child_span.innerHTML = ""; 
		        return;
		    }
		    child_span.innerHTML = "<img src='<?php echo JURI::root(); ?>/plugins/joomsuite_content_fields/images/select_relate/loader.gif'>";
		  
		    xajax_jsCallPlugin( 'joomsuite_content_fields', 'select_relate', 'xajax_expandChild', [ <?php echo $obj->id; ?>, parent, value ] );
		  }
		
		  function JSnewValue<?php echo $obj->id; ?>( level, mode )
		  {
		    var spanlist = document.getElementById( 'fields<?php echo $obj->id; ?>_spanlist_'+level );
		    var spantext = document.getElementById( 'fields<?php echo $obj->id; ?>_spantext_'+level );
		    var uservalue_switch = document.getElementById( 'fields<?php echo $obj->id; ?>_uservalue_switch_'+level );
		    
		    switch( mode ) {
		      case 0 :
		        spanlist.style.display = "none";
                spantext.style.display = "inline";
                uservalue_switch.value = "text";
                var child_span = document.getElementById( 'sr_span_<?php echo $obj->id; ?>_' + ( level + 1 ) );
                //child_span.innerHTML = '<a href="javascript:JSnewTextField<?php echo $obj->id; ?>( ' + ( level + 1 ) + ', 0 )"><?php echo JText::_($params->get( "user_value_label" )); ?></a>';
                child_span.innerHTML = "";

		        break;
		      case 1 :
		        spanlist.style.display = "inline";
		        spantext.style.display = "none";
		        uservalue_switch.value = "list";
		        
		        var list = document.getElementById( 'fields<?php echo $obj->id; ?>_' + level );
		        list.value = "";
		        
            break;
		    }
		  }
      
	      function JStextFieldShower<?php echo $obj->id; ?>( value, level )
	      {
	         
	          var span = document.getElementById( 'sr_span_<?php echo $obj->id; ?>_' + level );
              
              var level_labels = [ <?php  echo count( $level_labels ) ? "'".implode( "', '", $this->jsLevelValues( $level_labels ) )."'" : ""; ?> ]
              
	          if( !span.innerHTML
	              && value
	              && <?php echo $params->get( "max_level" ) != "-1" ? "level <= ".$params->get( "max_level" ) : "1"; ?>
	              && <?php echo "level >= ".$params->get( "min_user_value_level" ); ?> ) {
	              
	              if( level_labels.length ) {
		              var level_label = ( typeof  level_labels[ level - 1] != 'undefined' ? level_labels[level - 1] : "" ) + '<br>';
		          } else {
		              var level_label = "";
		          } 
	              
	              if( ( level ) > 1 ) {
		               var arrow = "<span class='sr_arrow_img' style='background:url( \"<?php echo JURI::root(); ?>plugins/joomsuite_content_fields/images/select_relate/arrow.png \") no-repeat right 50%;'> "+( level_labels.length ? "<br>" : "" )+'<span style="visibility:hidden">.</span> </span>';
		          }
	              
	              span.innerHTML = arrow + "<span class='sr_border'>" +
	                                   level_label +
	                                   "<input type='text' name='fields[<?php echo $obj->id; ?>][uservalue]["+( level-1 )+"]' onblur='JStextFieldHider<?php echo $obj->id; ?>( this.value, "+( level + 1 )+" )' onkeyup='JStextFieldShower"+<?php echo $obj->id; ?>+"( this.value, "+( level + 1 )+" )'>" +
                                       "<input type='hidden' value='text' name='fields[<?php echo $obj->id; ?>][uservalue_switch]["+( level-1 )+"]' id='fields<?php echo $obj->id; ?>_uservalue_switch_"+( level )+"'>" +
                                       '<img src="<?php echo JURI::root(); ?>plugins/joomsuite_content_fields/images/select_relate/delete.png" class="sr_delete_img" onclick="JStextFieldHider<?php echo $obj->id; ?>( \'\', ' + ( level + 1 ) + ' )"/>' +
                                   "</span>" +
                                   "<span id='sr_span_<?php echo $obj->id; ?>_" + ( level + 1 ) + "'></span>";
                                   
	          }
	      }
	      
	      function JStextFieldHider<?php echo $obj->id; ?>( value, level )
	      {
	          var spanlist =  document.getElementById( 'fields<?php echo $obj->id; ?>_spanlist_' + ( level - 1 ) );
	          var spantext =  document.getElementById( 'fields<?php echo $obj->id; ?>_spantext_' + ( level - 1 ) );
	          
	          if( !value ) {
	              
	              if( typeof document.adminForm['fields[<?php echo $obj->id; ?>][uservalue][' + ( level - 2 ) + ']'] != "undefined" ) {
	                document.adminForm['fields[<?php echo $obj->id; ?>][uservalue][' + ( level - 2 ) + ']'].value = "";
	              }
	              
	              if( typeof document.adminForm['fields[<?php echo $obj->id; ?>][main]['+( level - 2 ) + ']'] != "undefined" ) {
                    document.adminForm['fields[<?php echo $obj->id; ?>][main]['+( level - 2 ) + ']'].value = "";
                  }
                  
                  if( spanlist ) spanlist.style.display = "inline";
                  if( spantext ) spantext.style.display = "none";
                  
                  document.getElementById( "fields<?php echo $obj->id; ?>_uservalue_switch_" + ( level - 1 ) ).value = "list";
                  
	              var span = document.getElementById( 'sr_span_<?php echo $obj->id; ?>_' + level );
	              span.innerHTML = "";
	          }
	      }
	  </script>
	  <?php
	}
	
	function jsLevelValues( $level_labels )
	{
        foreach( $level_labels as $v ) {
            $prepared_labels[] = htmlspecialchars( $v, ENT_QUOTES );
        }
        
        return $prepared_labels;
    }
	
	function renderList( $field_id, $parent, $level, $current_value, &$options, &$params, $user_variant, $level_labels )
	{
		$html = "";
		
		if( $level > 1 ) {
		  $html.= '<span class="sr_arrow_img" style="background:url( '.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/arrow.png ) no-repeat right 50%;"> '.( count( $level_labels ) ? "<br>" : "" ).'<span style="visibility:hidden">.</span> </span>';
		}
		
		$event = "onchange=\"JSexpandChild".$field_id."( ".( is_null( $parent ) ? "'null'" : $parent ).", this.value, ".$level." );\"";
		$html.= '<span class="sr_border">';
		if( count( $level_labels ) ) {
		  $html.= ( isset( $level_labels[$level - 1] ) ? $level_labels[$level - 1] : "" ).'<br>';
		}
		if( $user_variant ) {
			$html.= '<span id="fields'.$field_id.'_spanlist_'.$level.'">';
			  $html.= JHTML::_('select.genericlist', $options, 'fields['.$field_id.'][main]['.($level-1).']', 'class="inputbox" '.$event ,'value', 'text', htmlspecialchars( $current_value ), "fields".$field_id."_".$level );
			$html.= '</span>';
			$html.= '<span id="fields'.$field_id.'_spantext_'.$level.'" style="display:none">';
			  $html.= '<input type="text" name="fields['.$field_id.'][uservalue]['.($level-1).']" onblur="JStextFieldHider'.$field_id.'( this.value, '.( $level + 1 ).' )" onkeyup="JStextFieldShower'.$field_id.'( this.value, '.( $level + 1 ).' )">';
			$html.= '</span>';
		} else {
			$html.= '<span id="fields'.$field_id.'_spanlist_'.$level.'">';
			  $html.= JHTML::_('select.genericlist', $options, 'fields['.$field_id.'][main]['.($level-1).']', 'class="inputbox" '.$event ,'value', 'text', htmlspecialchars( $current_value ), "fields".$field_id."_".$level );
			$html.= '</span>';
		}
		$img_onclick = 'onclick="JStextFieldHider'.$field_id.'( \'\', '.( $level + 1 ).' )"';
		
		$html.= '<input type="hidden" name="fields['.$field_id.'][uservalue_switch]['.($level-1).']" value="list" id="fields'.$field_id.'_uservalue_switch_'.$level.'">';
		$html.= '<img src="'.JURI::root().'plugins/joomsuite_content_fields/images/select_relate/delete.png" class="sr_delete_img" '.$img_onclick.'/>';
		$html.= '</span>';

		return $html;
	}

	function generateOptions( & $values, & $dump_values, $sort_mode, $max_level, $user_variant, &$params ) {
		$result = array();
		$options_dump = array();
		$max_len = 0;
		 
		foreach( $values as $value ) {
			$len = JString::strlen( $dump_values[$value]['value'] );
			$max_len = $len > $max_len ? $len : $max_len;
		}
		 
		foreach( $values as $value ) {
			$len = JString::strlen( $dump_values[$value]['value'] );
			 
			$sign = "";
			 
			if( $params->get( "show_children_amount" ) && $dump_values[$value]['children'] && ( $max_level != "-1" && $dump_values[$value]['level'] < $max_level || $max_level == "-1" ) ) {
				$sign = "(".$dump_values[$value]['children'].")";
			}
			 
			$options_dump[$dump_values[$value]['value']] = JText::_($dump_values[$value]['value'])."&nbsp;&nbsp;".$sign;
		}
		 
		if( $sort_mode == 2 ) ksort( $options_dump );
		if( $sort_mode == 3 ) krsort( $options_dump );

		$result[] = JHTML::_( 'select.option', "", "" );

		foreach( $options_dump as $value_option => $text_option ) {
			$result[] = JHTML::_( 'select.option', $value_option, $text_option );
		}
		
		if( $user_variant ) {
		  $result[] = JHTML::_( 'select.option', JText::_($params->get( "user_value_label" )), JText::_($params->get( "user_value_label" )) );
		}

		return $result;
	}

	function getValuesByParent( & $dump_values, $parent )
	{
		$result = array();
		 
		foreach( $dump_values as $key => $value) {
			if( $value["parent"] === $parent ) {
				$result[] = $key;
			}
		}
		 
		return $result;
	}

	function findNewParent( & $values, & $dump_values, $needle )
	{
		foreach ( $values as $value ) {
			if( $dump_values[$value]["value"] == $needle ) {
				return $value;
			}
		}
	}

	function parseValues( $param_values )
	{
		$v_lines = explode( "\n", $param_values );

		$result = array();
		$matches = array();
		$current_nesting = array( );


		foreach( $v_lines as $line_num => $line ) {
			$line = trim( $line );

			if( !$line ) continue;

			preg_match( "/^([> ]*)(\{([^\{\}]*)\})?(.*)$/", $line, $matches );
			
			$level_prefix = $matches[1];
			$alt_value = JString::strlen( $matches[3] ) < JString::strlen( $matches[2] ) ? $matches[3] : null;
			$value = $matches[4];

			$level = substr_count( $level_prefix, ">" ) + 1;

			$current_level = count( $current_nesting );

			if( $level - $current_level >= 2 ) {
				return false;
			}

			if( $level - $current_level == 1 ) {
				$current_nesting[] = count( $result );
			}

			if( $level == $current_level ) {
				$current_nesting[count( $current_nesting ) - 1] = count( $result );
			}

			if( $level < $current_level ) {
				if( $level == 1 ) {
					$current_nesting = array( count( $result ) );
				} else {
					$current_nesting = array_slice ( $current_nesting, 0, - ( count( $current_nesting ) - $level ) );
				}
				$current_nesting[count( $current_nesting ) - 1] = count( $result );
			}

			$parent = isset( $current_nesting[ count( $current_nesting ) - 2 ] ) ? $current_nesting[ count( $current_nesting ) - 2 ] : null;

			$result[] = array( "parent" => $parent, "level" => $level, "value" => $value, "children" => 0, 'alt_value' => $alt_value );

			if( $parent !== null ) {
				$result[$parent]["children"] ++;
			}
		}
		return $result;
	}

	function addChild( & $dump_values, $parent, $value, $alt_value = null )
	{
		if( $parent !== null ) {
			$dump_values[$parent]["children"] ++;
			$level = $dump_values[$parent]["level"] + 1;
		} else {
			$level = 1;
		}
		$dump_values[] =  array( "parent" => $parent, "level" => $level, "value" => $value, "children" => 0, "alt_values" => $alt_value );
	}

	function dumpToString( $dump_values )
	{
		$preparedDump = $this->prepareDump( $dump_values );
		return implode( "\n", $preparedDump );
	}

	function prepareDump( $dump_values, $parent = null )
	{
		$result = array();

		$children = $this->getValuesByParent( $dump_values, $parent );

		foreach( $children as $child ) {
			$alt_value = $dump_values[$child]["alt_value"] !== null ? "{".$dump_values[$child]["alt_value"]."}" : "";
			$result[] = str_repeat( ">", $dump_values[$child]["level"] - 1 ).$alt_value.$dump_values[$child]["value"];
			if( $dump_values[$child]["children"] ) {
				$result = array_merge( $result, $this->prepareDump( $dump_values, $child  ) );
			}
		}
		return $result;
	}

	function onBeforeSave( &$value, &$params, $type, $id, $row, &$error )
	{
		if( $type != 'select_relate' ) return;
		if( !$value ) return;
		
		$dump_values = $this->parseValues( $params->get( "values" ) );

		$db = JFactory::getDBO();

		$parent = null;

		$prepared_value = array();

		
		
		foreach( $value["uservalue_switch"] as $key => $switcher ) {

			if( ( $switcher == "list" && !$value["main"][$key] ) || ( $switcher == "text" && !$value["uservalue"][$key] ) ) break;

			$level = $key + 1;

			$part_of_values = $this->getValuesByParent( $dump_values, $parent );

			switch( $switcher ) {
				case "list":
					$current_value = $value["main"][$key];

					break;
				case "text":
					$current_value = $value["uservalue"][$key];

					$this->addChild( $dump_values, $parent, $current_value );
					$part_of_values = $this->getValuesByParent( $dump_values, $parent );
					break;
			}
			
			$parent = $this->findNewParent( $part_of_values, $dump_values, $current_value );

			$prepared_value[] = $current_value;
		}

		
		if( $params->get( "min_level" ) != -1 && $params->get( "min_level" ) > count( $prepared_value ) ) {
			$db->setQuery( "SELECT title FROM #__js_res_fields WHERE id = ".$id );
			$field_title = $db->loadResult();

			$error = true;
			JError::raiseWarning( '111', JText::sprintf( 'Field "%s" is not filled completely. Need to fit the minimum nesting level', $id.$field_title), '');
			return;
		}

		$dump_in_string = $this->dumpToString( $dump_values );

		$params->set( "values", $dump_in_string );

		$db->setQuery( "UPDATE #__js_res_fields SET params = '".$db->getEscaped( $params->toString() )."' WHERE id = ".$id );
		$db->query();

		$value = implode( "\n", $prepared_value );
		 
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if( $field->type != 'select_relate' ) return;
		if( !$field->field_value ) return;

		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	

		$values = explode( "\n", $field->field_value );

        $dump_values = $this->parseValues( $params->get( "values" ) );

        $res_values = array();
        
        $parent = null;
        
        foreach( $values as $key => $value ) {
            //$separator = ( $key > 0 ? " " : "" );
            $part_of_values = $this->getValuesByParent( $dump_values, $parent );
            
            $parent = $this->findNewParent( $part_of_values, $dump_values, $value );
            if( !isset( $dump_values[$parent] ) ) {
            	//$res_values[] = $separator.JText::_($value);
            	$res_values[] = JText::_($value);
            } else {
            	if( $dump_values[$parent]["alt_value"] !== null && !( $key + 1 == count( $values ) && !trim( $dump_values[$parent]["alt_value"] ) ) ) {
                    $res_values[] = JText::_($dump_values[$parent]["alt_value"]);
            	} else {
                    //$res_values[] = $separator.JText::_($dump_values[$parent]["value"]);
                    $res_values[] = JText::_($dump_values[$parent]["value"]);
            	}
            }
        }
		
		switch( $params->get( "show_value_format" ) ) {
			case "last_only" :
				$out = $res_values[ count( $res_values ) - 1 ];
				break;
			case "all_in_line" :
				$out = implode( ", ", $res_values );
				break;
			case "all_in_column" :
				$out = implode( "<br>", $res_values );
				break;
		}
	}
}
