<?php
/**
 * @fileID: $Id: jsbookmarkitem.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementJsbookmarkitem extends JElement
{

	function fetchElement($name, $value, &$node, $control_name)
	{
		$db	=& JFactory::getDBO();
		
		$url    = $node->attributes('url');
		$image  = $node->attributes('image');
		$width  = $node->attributes('width');
                $height = $node->attributes('height');
		
		$composed_value = serialize( array( 'element_type' => 'bookmarks', 'url' => $url, 'image' => $image, 'show' => true, 'height'=>$height, 'width'=>$width ) );
		$empty_value	= serialize( array( 'element_type' => 'bookmarks', 'url' => $url, 'image' => $image, 'show' => false, 'height'=>$height, 'width'=>$width ) );
		if (!is_array($value))
		{
			$value = array($value, 'n');
		}
		
		if( !@$value[0] ) {
			$selected = htmlspecialchars( $composed_value );
		} else {
			$selected = htmlspecialchars( @$value[0] );
		}
		
		$arr = array(
			JHTML::_('select.option',  htmlspecialchars( $empty_value ), 	JText::_( "No" ) ),
			JHTML::_('select.option',  htmlspecialchars( $composed_value ), JText::_( "Yes" ) )
		);
		
		$out = '<img src="'.JURI::root().'/plugins/joomsuite_content_fields/images/jsbookmarks/'.$image.'">';
		$out .= JHTML::_('select.radiolist',  $arr, $control_name.'['.$name.'][0]', '', 'value', 'text', $selected );
		
		$checked = '';
		if (@$value[1] == '1')
			$checked = ' checked="checked" ';
//		else {
//			echo '<pre>';
//			var_dump($value);
//			echo '</pre>';
//		}
		
		$out .= ' | '. JText::_('On top').': <input type="checkbox" name="'.$control_name.'['.$name.'][1]" class="inputbox" value="1"'.$checked.' />';
		//Share this page with reddit
		return $out;
	}
}