<?php
/**
 * @fileID: $Id: jschildrelatefield2.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementJschildrelatefield2 extends JElement
{

	function fetchElement($name, $value, &$node, $control_name)
	{
		$db	=& JFactory::getDBO();
		
		$sql1 = "    SELECT t.id    AS type_id,
		                   t.name  AS type_name,
		                   f.id    AS field_id,
		                   f.title AS field_name"
		    ."\n      FROM #__js_res_types AS t"
		    ."\n LEFT JOIN #__js_res_fields AS f ON f.type_id = t.id AND f.published = 1"
		    ."\n     WHERE t.published = 1"
		    ."\n  ORDER BY t.id"
	 	;
	 	
	 	$sql = "SELECT
		  t.id AS type_id,
		  t.name AS type_name,
		  f.id AS field_id,
		  f.title AS field_name,
		  f.type
		FROM
		  #__js_res_types AS t
		    LEFT JOIN
		  #__js_res_fields AS f
		    ON f.type_id = t.id AND f.published = 1
		
		WHERE
		  t.published = 1 AND f.type <> 'relate_parent'
		ORDER BY
		  t.id";
	 	
	 	$db->setQuery( $sql );
	 	
		$result = $db->loadObjectList();

		$types = array(); 
		
		foreach( $result as $type ){
			$types[$type->type_id][$type->field_id] = $type->field_name;
		}
		
		$sub_options[] = "'': {'':' - ".JText::_( 'Related field is not selected' )." - '}";
		
		foreach( $types  as $type_id => $fields ) {
			$t = array();
			
			foreach( $fields as $field_id => $field_name ) {
				$t[] ="'".$field_id."':'".str_replace( "'", "\\'", $field_name )."'";
			}
			
			$sub_options[] = "'".$type_id."': {".implode( ",", $t )."}";
		}

		$empty_option[] = JHTML::_( 'select.option', '0', ' - '.JText::_( 'Related field is not selected' ).' - ' );

 		$html[]	= JHTML::_( 'select.genericlist', $empty_option, "{$control_name}[{$name}][]", 'size="10" multiple="1"', 'value', 'text', $value , 'js_sublist_'.$name);

    $html[] = "
		<script type='text/javascript'> <!--";
		$html[] = "JS_list_options_".$name." = {".implode(",\n", $sub_options)."}";
		$html[] = "JS_saved_value_".$name." = '".$value."'";
		$html[] = "
		   function JS_addOption( list, value, text  ) {
		       var newOption = document.createElement('OPTION');
		       newOption.text  = text;
		       newOption.value = value;
		       (list.options.add) ? list.options.add(newOption) : list.add(newOption, null);
		   }";
		$html[] = "
		   function JS_refreshSubList_".$name."( ) {
		     var list = document.getElementById('paramsparent_type');
		     var ident = '".$name."';
		     var options = JS_list_options_".$name.";
		     var current_options = null;
		     
		     for( type_id in options) {
		       if( list.value == type_id ) {
		          current_options = options[type_id];
		       }
		     }
		     
		     var sublist = document.getElementById('js_sublist_'+ident);
		     sublist.length = 0;
		     
		     if (list.value != '')
		     	JS_addOption(sublist, 0, ' - ".JText::_( 'None' )." - ');
		     for ( k in current_options) {
		       JS_addOption(sublist, k, current_options[k]);
		     }
		     if( JS_saved_value_".$name." != -1 ) {
		       sublist.value = JS_saved_value_".$name.";
		       JS_saved_value_".$name." = -1;
		     }
		   }";
    $html[] = "
       var relatefields = document.getElementById('paramsparent_type');
       
       if( relatefields.addEventListener && navigator.appName != 'Opera' ) {
	       relatefields.addEventListener( 'change', JS_refreshSubList_".$name.", true);
	     } else {
	       relatefields.attachEvent( 'onchange', JS_refreshSubList_".$name.");
	     }
	     
       JS_refreshSubList_".$name."( );
       
    ////--></script>";
		 
		return implode( "\n", $html );
	}
}