<?php
/**
 * @fileID: $Id: jsselectrelateconstructor.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementJSSelectRelateConstructor extends JElement
{
	var	$_name = 'JSSelectRelateConstructor';

	function fetchElement( $name, $value, &$node, $control_name )
	{
		$document = & JFactory::getDocument();
		$document->addScript( JURI::root()."plugins/joomsuite_content_fields/select_relate.js" );

		$value = $value ? $value : "Mercedes\n>E-Class\n>>230 CDI\n>>350 4matic\n>C-Class\nBMW\n>Q7\n>Q5";
		
		
		$rows = $node->attributes('rows');
		$cols = $node->attributes('cols');
		$class = ( $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="text_area"' );
		
		$value = str_replace('<br />', "\n", $value);

		$html = '<textarea name="'.$control_name.'['.$name.']" cols="'.$cols.'" rows="'.$rows.'" '.$class.' id="'.$control_name.$name.'" >'.$value.'</textarea>';
		$html .= "<script>SRElementHelper.setParams( { 'param_id'        : '".$control_name.$name."',
                                                       'add_img_path'    : '".JURI::root()."plugins/joomsuite_content_fields/images/select_relate/add.png',
                                                       'remove_img_path' : '".JURI::root()."plugins/joomsuite_content_fields/images/select_relate/remove.png',
	                                                   'lang_ROOT'       : '".JText::_( "ROOT" )."',
                                                       'lang_child'      : '".JText::_( "child" )."',
                                                       'lang_sibling'    : '".JText::_( "sibling" )."',
                                                       'lang_remove'     : '".JText::_( "remove" )."',
                                                       'lang_cancel'     : '".JText::_( "cancel" )."',
                                                       'lang_apply'      : '".JText::_( "apply" )."' } );</script>";
		
		$html .= '<center><input type="button" onclick="SRElementHelper.switchToConstructor(); SRElementHelper.background.innerHTML += \' \';" style="cursor:pointer" value="'.JText::_( "Switch to constructor view" ).'"></center>';
		return $html;
	}
}
