<?php
/**
 * @fileID: $Id: yui.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
		
	$rootUrl = JURI::root();
	$libImagesUrl = $rootUrl.'plugins/joomsuite_content_fields/images/gallery/';
	
	$skinParams = $params->get('skin');
	
	// The display options.
	$displayType 	= $this->i($skinParams, 1, 0); // $params->get('display_type', 0);
	$useShadowbox 	= $params->get('use_shadowbox', 1);
	$showBigThumb 	= ($displayType == 0 || $displayType == 4 || $displayType == 5);
	$showCarousel 	= ($displayType == 0 || $displayType == 1);

	// Show only thumbs, without any carousel and shadowbox.
	$thumbsOnly		= in_array($displayType, array(2, 3, 4, 5));
	$randomThumb 	= ($displayType == 3) || ($displayType == 5);
	$show_type = $params->get('show_filename');
	$show_type_image = $params->get('show_filename_image');
	$iPicture = 0;
	if ($randomThumb)
		$iPicture = array_rand($data['files']['name']); 
	
		
	$showPicturesOnScroll = $this->i($skinParams, 3, 0); //$params->get('select_on_scroll', 0);
	if ($showCarousel && !$showBigThumb)
		$showPicturesOnScroll = false;
	
	
	$document = &JFactory::getDocument();
	
	$scriptDir = 'media/mightyextensions/js';
	
	$document->addScript($rootUrl.$scriptDir.'/yui/build/utilities/utilities.js');
	if ($showCarousel) {
		$document->addStyleSheet($rootUrl.$scriptDir.'/yui/build/carousel/assets/skins/sam/carousel.css');
		$document->addStyleSheet($rootUrl.$scriptDir.'/yui/build/carousel/assets/skins/sam/carousel-skin.css');
		$document->addStyleSheet($rootUrl.$scriptDir.'/yui/build/fonts/fonts-min.css');
		$document->addScript($rootUrl.$scriptDir.'/yui/build/carousel/carousel-beta-min.js');
	}
	
	if ($useShadowbox) {
		$document->addScript($rootUrl.$scriptDir.'/shadowbox/build/adapter/shadowbox-base.js');
		$document->addScript($rootUrl.$scriptDir.'/shadowbox/build/shadowbox.js');
		$document->addStyleDeclaration('#shadowbox_title {border: 0px solid;}#shadowbox_info {border: 0px solid;}');
	}
	
	
	// The magic UID!! %))
	$uid = uniqid('gallery2');
	$url = JURI::root() .$folder.'/'.$user.'/';
	$theFiles = $this->getFiles($data['files'], $url, $field->record_id, $params, $article->user_id, $field->id);
	// my Gal must be UniquE :))
	$gallery_name = 'myGal_'.$uid;
	
	$thumbHeight = $params->get('thumb_height', 120);
	if ($params->get('show_filename', 1))
		$thumbHeight += 20;
		
	// number of thumbs to display in carousel
	$totalItems = count($data['files']['name']);
	$cThumbsInCarousel = min((int)$this->i($skinParams, 2, 5), $totalItems);
	

	
	$ext = JFile::getExt($theFiles[$iPicture]->name);
        $firstPictureSize = '';
	if (in_array($ext, $this->video))
		$firstPicture = $libImagesUrl.'video.png';
	else {
		$firstPicture = $theFiles[$iPicture]/*->bigthumb*/;
	}
	
	// Inlucde the common CSS
	ob_start();
	?>
div.main_gall_carousel_images ol#<?php echo $uid; ?>carousel {
	padding: 0;
	margin: 0;
	width: <?php echo ($params->get('thumb_width', 120) + 10) * $totalItems; ?>px;
}
div.main_gall_carousel_images ol#<?php echo $uid; ?>carousel li {
	text-align: center;
	list-style: none;
	margin: 4px;
}
div.main_gall_carousel_images ol#<?php echo $uid; ?>carousel li img {
	border: 2px solid #f3f3f3;
}
div.main_gall_carousel_images ol#<?php echo $uid; ?>carousel li.yui-carousel-item-selected {
	border: 1px solid #f3f3f3;
}
div.main_gall_carousel_images ol#<?php echo $uid; ?>carousel li.yui-carousel-item-selected img{
    border: 2px solid #8a8a8a;
}

div.main_gall_carousel_images ol#<?php echo $uid; ?>carousel li h4 {
	font-size: 80%;
	font-weight: normal;
	padding: 0;
	margin: 0;
}
div.yui-carousel-nav {
	display: none;
}

.yui-carousel .yui-carousel-item-selected {
	margin: 4px;
}
<?php 
	$document->addStyleDeclaration(ob_get_clean());
	ob_start();
?>
<?php if ($showCarousel) : ?>
    #<?php echo $uid; ?>carousel.yui-carousel-element li {
    	height: <?php echo $thumbHeight; ?>px;
		width: <?php echo $params->get('thumb_width', 120); ?>px;
        text-align: left;
    }
/* ---------------------------------------- */
#<?php echo $uid; ?>main_gall {
/*width: 500px;*/
margin-bottom: 20px;
}
#<?php echo $uid; ?>main_gall_navig {
height: 40px;
text-align: center;
background: url('<?php echo $libImagesUrl; ?>navig-line.jpg') no-repeat center 21px;
}
#<?php echo $uid; ?>container {
float: left;
width: <?php echo $cThumbsInCarousel * ((int)$params->get('thumb_width', 120) + 10); ?>px;
}
.main_gall_navig_pagenum {
font: 200% Trebuchet MS;
color: #000;
padding: 0 5px;
}
img.prev_page, img.next_page {
width: 21px;
height: 21px;
cursor: pointer;
}
#<?php echo $uid; ?>main_gall_carousel span.left_button {
width: 30px;
float: left;
padding-top: 9px;
}
#<?php echo $uid; ?>main_gall_carousel span.left_button img.left_scroll, 
#<?php echo $uid; ?>main_gall_carousel span.right_button img.right_scroll {
width: 25px;
height: 80px;
cursor: pointer;
}
#<?php echo $uid; ?>main_gall_carousel span.right_button {
	width: 30px;
	float: left;
	padding-top: 9px;
}

#<?php echo $uid; ?>main_gall_carousel {
	width: <?php echo ($params->get('thumb_width', 120) + 10) * $cThumbsInCarousel + 60 + 5; ?>px;
}

<?php endif; ?>

<?php if ($useShadowbox) : ?>
#<?php echo $uid; ?>imageHolder, #<?php echo $uid; ?>container .carousel_item img {
	cursor: pointer;
<!--	height: 140px;-->
}
<?php endif; ?>	

<?php if ($showBigThumb) :?>
#<?php echo $uid; ?>image {
	height: <?php echo $params->get('max_height'); ?>px;
	width: <?php echo $params->get('max_width'); ?>px;
<?php if (!$thumbsOnly) : ?>
	background: <?php echo $params->get('holder_bg', '#000000');?>;
<?php endif; ?>
}
<?php endif; ?>
<?php 
	// Add the CSS
	$document->addStyleDeclaration(ob_get_clean());
?>
<?php if ($showBigThumb || $useShadowbox) : ?>
<script type="text/javascript">
	var <?php echo $uid; ?>Photos = <?php echo $this->playlist_to_object($data['files'], $url, $field->record_id, $params, $article->user_id, $field->id); ?>;
	var <?php echo $uid; ?>toOpen = [];
	
	for (var i = 0; i < <?php echo $uid; ?>Photos.length; i++){
		<?php echo $uid; ?>toOpen.push({
			content: <?php echo $uid; ?>Photos[ i ].original,
			player: <?php echo $uid; ?>Photos[ i ].player,
			options: <?php echo $uid; ?>Photos[ i ].options
		});
	}
</script>
<?php endif; ?>
<div id="<?php echo $uid; ?>clear"></div>
<?php if ($showBigThumb) : ?>
<?php if ($showCarousel && $showBigThumb) : ?>
<table width="100%">
<tr>
<td align="center">
<?php endif; ?>
<div id="<?php echo $uid; ?>image">
	<?php if ($showCarousel && $showBigThumb) : ?>
	<table height="100%" cellpadding="0" cellspacing="0" style="margin: 0 auto; border: 0px none;table-layout: auto">
		<tr valign="middle" style="padding:0px;margin:0px;">
	<?php endif; ?>
	<?php if ($showCarousel && $showBigThumb) : ?>
			<td align="center" style="padding:0px;margin:0px;">
	<?php endif; ?>
				<img title="<?php echo $useShadowbox ? JText::_('Click to view') : ''; ?>"  id="<?php echo $uid; ?>imageHolder" <?php if (!empty($firstPicture)) echo 'src="', $firstPicture->bigthumb, '"'; ?> />
				
	<?php if ($showCarousel && $showBigThumb) : ?>
			</td>
		</tr>
	</table>
	<?php endif; ?>
</div>
<?php if ( $show_type_image &&  isset($firstPicture->$show_type_image)): ?>
	<span id="<?php echo $uid; ?>titleHolder" ><?php  echo html_entity_decode($firstPicture->$show_type_image); ?></span>
<?php endif; ?>
<div class="clr"></div>
<?php if ($showCarousel && $showBigThumb) : ?>
</td>
</tr>
<tr>
<td align="center">
<?php endif; ?>
<?php endif; ?>

<?php if ($showCarousel) : ?>
<div id="<?php echo $uid; ?>main_gall">
<?php if ($showBigThumb): ?>
<div id="<?php echo $uid; ?>main_gall_navig" style="text-align: center">
<span class="prev_page">
<img id="<?php echo $uid; ?>goleft" src="<?php echo $libImagesUrl; ?>prev_page.png" title="<?php echo JText::_('Previous Page'); ?>" class="prev_page" />
</span>
<span id="<?php echo $uid; ?>nav_page" class="main_gall_navig_pagenum">1</span>
<span class="next_page">
<img id="<?php echo $uid; ?>goright" src="<?php echo $libImagesUrl; ?>next_page.png" title="<?php echo JText::_('Next Page'); ?>" class="next_page" />
</span>
</div>
<?php endif; ?>

<div id="<?php echo $uid; ?>main_gall_carousel">
<span class="left_button">
<img title="<?php echo JText::_('Scroll left'); ?>" src="<?php echo $libImagesUrl; ?>left_scroll.png" id="<?php echo $uid; ?>prev_image" class="left_scroll" />
</span>
<div class="main_gall_carousel_images" id ="<?php echo $uid; ?>container" style="display: none">
    <ol id="<?php echo $uid; ?>carousel" style="margin:0;padding:0;">
<?php
$minWH = min($params->get('thumb_height', 120), $params->get('thumb_width', 120));

foreach ($theFiles as $p) {
	$ext = JFile::getExt($p->name);
	$video = in_array($ext, $this->video);
?>
        <li class="carousel_item">
            <span title="<?php echo $p->title; ?>">
                <img border="0"
                <?php if ($video) echo ' height="', $minWH, 'px" width="', $minWH, 'px" '; ?>
                     alt="<?php echo $p->name; ?>"
                     src="<?php echo $p->thumb; ?>"
                     <?php echo $p->thumbSize[3]; ?>/>
            </span>
            <?php if ( $show_type ): ?>
            	<h4 style="font-size: 80%;"><?php echo (mb_strlen(html_entity_decode($p->$show_type)) > 15 ? mb_substr(html_entity_decode($p->$show_type), 0, 15).'...' : html_entity_decode($p->$show_type)) ?></h4>
            <?php endif; ?>
        </li>
<?php
} 
?>
    </ol>
</div>
<span class="right_button">
<img title="<?php echo JText::_('Scroll right'); ?>" src="<?php echo $libImagesUrl; ?>right_scroll.png" id="<?php echo $uid; ?>next_image" class="right_scroll" />
</span>
<div class="clr"></div>
</div>
</div>
<input style="position: relative;left: -10000px; width: 2px;" id="<?php echo $uid; ?>hack" type="button" value="-">
<?php if ($showBigThumb && !$thumbsOnly) : ?>
</td>
</tr>
</table>
<?php endif; ?>
<?php endif; // Show carousel ?>
<script>
<?php if ($useShadowbox) : ?>
Shadowbox.loadSkin('classic', '<?php echo $rootUrl.$scriptDir ?>/shadowbox/build/skin');
Shadowbox.loadLanguage('en', '<?php echo $rootUrl.$scriptDir ?>/shadowbox/build/lang');
Shadowbox.loadPlayer(['img', 'flv', 'qt', 'wmp'], '<?php echo $rootUrl.$scriptDir ?>/shadowbox/build/player');
<?php endif; ?>
(function () {
	var Dom = JS_YAHOO.util.Dom;
	var Event = JS_YAHOO.util.Event; 
                
    JS_YAHOO.util.Event.onDOMReady(function (ev) {
        <?php if ($useShadowbox) : ?>

		// Shadowbox.getOptions()['flvPlayer'] = '<?php echo $rootUrl.$scriptDir; ?>/shadowbox/flvplayer.swf';

		Shadowbox.init({
			overlayColor: '#123456',
			counterType: 5,
			counterLimit: 10,
			handleOversize: 'resize',
			gallery: '<?php echo $gallery_name; ?>',
			enableKeys: false
		});
		Shadowbox.getOptions()['flvPlayer'] = '<?php echo $rootUrl; ?>plugins/joomsuite_content_fields/media.swf';
		<?php endif; ?>
	
		Dom.addClass(document.body, 'yui-skin-sam');
		Dom.get("<?php echo $uid; ?>container").style.display = 'block';
	
		// Add 'onclick' event listener for big thumbnail.
		<?php if ($useShadowbox) : ?>
		var holder = Dom.get('<?php echo $uid; ?>imageHolder');
		Event.addListener(holder, 'click', 
			function() {					
				Shadowbox.open(
					<?php echo $uid; ?>toOpen, {
						continuous: true
					}
				);
				Shadowbox.change(carouselSelected);
				// Hack for Opera browsers				
				var f = Dom.get('<?php echo $uid; ?>hack');
				if ( f ) f.focus();
			}
		);
		<?php endif; ?>

		<?php if ($showCarousel): ?>
		var carouselSelected = <?php echo isset($iPicture) ? $iPicture : 0; ?>;			
	
		// Create the Carousel
		var Caru = new JS_YAHOO.widget.Carousel("<?php echo $uid; ?>container", {
			revealAmount: <?php echo min(100, (int)$this->i($skinParams, 4) /*$params->get('reveal_amount', 100)*/); ?>,
			animation: { speed: 0.5 },
			isCircular: true,
			numVisible: <?php echo (int)$cThumbsInCarousel; /*$params->get('visible_pics_count', 3)*/; ?>,
			disableSelection: true,
			selectOnScroll: <?php echo $showPicturesOnScroll == 0 ? 'false' : 'true';?>
		});
		
		Caru.STRINGS.NEXT_BUTTON_TEXT = '<?php echo JText::_("Next Page"); ?>';
		Caru.STRINGS.PAGER_PREFIX_TEXT = '<?php echo JText::_("Go to page"), ' '; ?>';
		Caru.STRINGS.PREVIOUS_BUTTON_TEXT = '<?php echo JText::_("Previous Page"); ?>';
		
		Caru.on('show', function() {
			var car = Dom.get('<?php echo $uid; ?>main_gall_carousel');
			var con = Dom.get('<?php echo $uid; ?>container');
			
			// align navbuttons vertically.
			var left = Dom.get('<?php echo $uid; ?>prev_image');
			var right = Dom.get('<?php echo $uid; ?>next_image');
			
			w = parseInt(car.offsetHeight/2 - 40) - 9;
			
			left.style.paddingTop = right.style.paddingTop = w + 'px';
		});
	            
	    Caru.render(); // get ready for rendering the widget
	    Caru.show();   // display the widget
	
	    // The page manager for carousel        
	    var pageManager = {
			nextPage: function() {
				var totalItems 		= Caru.get('numItems');
				var visibleItems 	= Caru.get('numVisible');
				var pages 			= parseInt(Math.ceil(totalItems / visibleItems));
				var curPage 		= Caru.get('currentPage');
				
				var nextPos		= ((curPage + 1) % pages) * visibleItems;
				Caru.scrollTo(nextPos);
			},
			prevPage: function() {
				var totalItems 		= Caru.get('numItems');
				var visibleItems 	= Caru.get('numVisible');
				var pages 			= parseInt(Math.ceil(totalItems / visibleItems));
				var curPage 		= Caru.get('currentPage');
				
				var nextPos		= ((curPage - 1 + pages) % pages) * visibleItems;
				Caru.scrollTo(nextPos);
			},
			setTitle: function(page) {
				var totalItems 		= Caru.get('numItems');
				var visibleItems 	= Caru.get('numVisible');
				var pages 			= parseInt(Math.ceil(totalItems / visibleItems));
				
				if (page >= 0 && page < pages)
					Dom.get('<?php echo $uid; ?>nav_page').innerHTML = page + 1;
			}
		};
		
		Event.addListener(Dom.get('<?php echo $uid; ?>goright'), 'click', pageManager.nextPage);
		Event.addListener(Dom.get('<?php echo $uid; ?>goleft'), 'click', pageManager.prevPage);
		
		Caru.on('itemSelected', function( e ) {
			<?php if ($showBigThumb) : ?>
			// Load the image into holder
			Dom.get('<?php echo $uid; ?>imageHolder').setAttribute('src', '<?php echo $rootUrl.$scriptDir; ?>/yui/build/carousel/assets/ajax-loader.gif');
			Dom.get('<?php echo $uid; ?>imageHolder').setAttribute('src', <?php echo $uid; ?>Photos[ e ].bigthumb);
			Dom.get('<?php echo $uid; ?>titleHolder').setHTML(<?php echo $uid; ?>Photos[ e ].title);
			<?php endif; ?>
			<?php if (!$showBigThumb && $useShadowbox) :?>
				Shadowbox.open(
					<?php echo $uid; ?>toOpen, {
						continuous: true
					}
				);
				Shadowbox.change( e );
			<?php endif; ?>
			carouselSelected = e;
		});
		Caru.on('selectedItemChange', function( e ) {
			// Hack for Opera browsers
			Dom.get('<?php echo $uid; ?>hack').focus();
		});  
		
		Caru.on('pageChange', function( e ) {
			// This stupid YUI carousel triggers pageChange event two times,
			// and each time passes different data, so workaround is here:
			if (typeof e.page != 'undefined') {
				return;
			}
	        pageManager.setTitle( e );
		});
	            
	    var left = Dom.get('<?php echo $uid; ?>prev_image');
		var right = Dom.get('<?php echo $uid; ?>next_image');
		
		Event.addListener(left, 'click', function() {
			Caru.scrollBackward();
		});
		Event.addListener(right, 'click', function() {
			Caru.scrollForward();
		});		
		<?php endif; ?>
    }); // onDomReady


    window.addEvent('domready', function() {
    	if (window.ie7) {
        	return;
        	
			var margin = -<?php echo (int)$cThumbsInCarousel; ?> * <?php echo 10 + $params->get('thumb_width', 120); ?>;
			$('<?php echo $uid; ?>carousel').setStyle('margin-left', '0px');
			new Element('div').setHTML(margin + 'px').inject(document.body);
			new Element('div').setHTML(margin + 'px').inject(document.body);
			new Element('div').setHTML(margin + 'px').inject(document.body);
			new Element('div').setHTML(margin + 'px').inject(document.body);
			new Element('div').setHTML(margin + 'px').inject(document.body);			
		}
    });
})();
</script>


<?php
// Show the small thumbnails. 
if ($thumbsOnly && !$showBigThumb) {
	$p  = $data['files'][ $iPicture ];
	
	if (!strlen( $p ))
		continue;
	$ext = JFile::getExt($p);
	
	$src = $url.$ext.'/gallery/thumbnail_small/'.$field->record_id.'_'.$params->get('thumb_width', 120).'_'.$params->get('thumb_height', 120).'_'.$p;
	$video = false;
	if (in_array($ext, $this->video)) {
		$video = true;
		$src = $libImagesUrl.'video.png';
	}
	
	$title = '';
	if ($useShadowbox)
		$title = ' title="'.JText::_('Click to enlarge').'" ';
	echo '<img ', $title, ' id="',$uid, 'imageHolder" src="', $src, '" />';
}
