<?php
/**
 * @fileID: $Id: likeit.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsLikeit extends JPlugin
{
	function plgJoomsuite_content_fieldsLikeit( &$subject, $params )
	{
	    //CREATE_TABLE
	    $sql= "CREATE TABLE IF NOT EXISTS `#__js_res_vote2` (
              `id` int(10) unsigned NOT NULL auto_increment,
              `user_id` int(10) unsigned NOT NULL default '0',
              `record_id` int(10) unsigned NOT NULL default '0',
              `field_id` int(10) unsigned NOT NULL default '0',
              `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
              `ip` varchar(16) NOT NULL default '',
              PRIMARY KEY  (`id`),
              KEY `record` (`record_id`),
              KEY `user` (`user_id`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	    
	    $db = &JFactory::getDBO();
	    
	    $db->setQuery($sql);
	    
	    if( $db->query() ){
	        
	        $filename = JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content_fields'.DS.'likeit.php';
	        $f = JFile::read($filename);
	        
	        $start = strpos($f, '//CREATE_TABLE');
	        $end = strpos($f, '//'.'END_CREATE_TABLE');
	        
	        $content = substr_replace($f, '', $start, $end - $start);
	        JFile::write($filename, $content);
	    }
	    //END_CREATE_TABLE
		parent::__construct( $subject, $params );
		$option = JRequest::getString('option');
		if( $option != 'com_resource' ){
		    JRequest::setVar('option', 'com_resource');
		    include_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'resource.xajax.php');
		    JRequest::setVar('option', $option);
		}
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'likeit') return;
         $user = &JFactory::getUser();
        if($user->gid > 19)
            $type = 'text';
        else
            $type = 'hidden';
		echo "<input type=\"{$type}\" name=\"fields[$obj->id]\" value=\"{$obj->field_value}\" />";
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'likeit') return;
		
		if( !$value )
		    $value = " 0 ";
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
	    static $script_added;
		if($field->type != 'likeit') return;
		if(!$field->field_value) $field->field_value = 0;

		$db = &JFactory::getDBO();
		$user = &JFactory::getUser();
		$sql = "SELECT id FROM #__js_res_vote2 WHERE field_id={$field->fid} AND record_id = {$record->id} AND user_id={$user->id} AND ip ='{$_SERVER['REMOTE_ADDR']}' ";
		$db->setQuery($sql);
		$result = $db->loadResult();
		
		$params = new JParameter($field->params);

		$doc = &JFactory::getDocument();
		$doc->addStyleSheet(JURI::root().'plugins/joomsuite_content_fields/likeit.css');


		if(!$result){
             $events = ' onmouseover="update(this,'.$record->id.','.$field->id.');" onmouseout="update(this,'.$record->id.','.$field->id.');" onclick="xajax_jsCallPlugin(\'joomsuite_content_fields\', \'likeit\', \'xajax_increment\', 
        					{recordid:'.$record->id.', fieldid:'.$field->fid.', id:'.$field->id.'});"';
            if( !$script_added ){
             $doc->addScriptDeclaration("
        		var up=0;
                function update(el, record_id, field_id){	
                	if(!up){
                		el.style.background='url(\"".JURI::root()."/plugins/joomsuite_content_fields/images/likeit/votebghover.png\")';
                		$('vote_container_' + record_id + '_' + field_id).getElements('span[class^=total]').setOpacity(0);
                		up=1;
                	}else{
                		el.style.background='url(\"".JURI::root()."/plugins/joomsuite_content_fields/images/likeit/votebg.png\")';
                		$('vote_container_' + record_id + '_' + field_id).getElements('span[class^=total]').setOpacity(1);
                		up=0;
                	}
                }
                ");
		        $script_added = true;
            }
            $style = 'style="cursor:pointer;"';
		}else{
		    $events = '';
		    $script = "";
		    $style = '';
		}
    		
		$out[] = '
		<div id="vote_container_'.$record->id.'_'.$field->id.'">
        	<div id="vote_totals_'.$record->id.'_'.$field->id.'" '.$style.' class="totals" title="'.JText::_($params->get('title')).'"'.$events.'>
        		<span class="totalvote">'.$field->field_value.'</span>
        		<span class="totaltext">'.JText::_($params->get('vote_text')).'</span>
        		<span class="titletext">'.JText::_($params->get('text')).'</span>
        	</div>
        </div>';
		
		$out = implode('',$out);
	}
	
	function xajax_increment( &$response, $recordid, $fieldid, $id) {
	    $params = ResHelper::getFieldParams($fieldid);
	    $db = &JFactory::getDBO();
	    $user = &JFactory::getUser();
	    $sql = "INSERT INTO #__js_res_vote2 VALUES (null,".$user->id.",".$recordid.",".$fieldid.",NOW(),'".$_SERVER['REMOTE_ADDR']."')";
	    $db->setQuery($sql);
	    $db->query();
	    $sql = "UPDATE #__js_res_record_values SET field_value = field_value + 1 WHERE id = {$id} AND record_id = {$recordid}";
	    $db->setQuery($sql);
	    if( $db->query() ){
	        $sql = "SELECT field_value FROM #__js_res_record_values WHERE id = {$id} AND record_id = {$recordid}";
	        $db->setQuery($sql);
	        $result = $db->loadResult();
	        $response->assign('vote_container_'.$recordid.'_'.$id,'innerHTML','
        	<div id="vote_totals_'.$recordid.'_'.$id.'" class="totals">
        		<span class="totalvote">'.$result.'</span>
        		<span class="totaltext">'.JText::_($params->get('aftervote_text')).'</span>
        		<span class="titletext">'.JText::_($params->get('text')).'</span>
        	</div>
	        ');
	    }else{
	        $response->assign('vote_container','innerHTML', 'Submit fail');
	    }
	    
	}
}