<?php
/**
 * @fileID: $Id: vote.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.database.table');

class APollVote extends JTable
{
    var $id         = null;
    var $user_id    = 0;
    var $ip         = '';
    var $option_id  = '';
    var $poll_id    = '';
    var $ctime      = '0000-00-00 00:00:00';

    function __construct( &$_db )
    {
        parent::__construct( '#__js_res_apoll_votes', 'id', $_db );
    }
    
    function loadByUser($user_id, $poll_id)
    {
    	$sql = 'SELECT id FROM #__js_res_apoll_votes WHERE user_id='.$user_id.' AND poll_id='.$poll_id;
    	$this->_db->setQuery($sql);
    	$vote_id = $this->_db->loadResult();
    	if($vote_id)
    	{
    		return parent::load($vote_id);
    	}
    	return false;
    	
    	
    }
    
    function loadByIp($ip, $poll_id)
    {
    	$ip = $this->_db->Quote($this->_db->getEscaped($ip));
    	$sql = 'SELECT id FROM #__js_res_apoll_votes WHERE ip='.$ip.' AND poll_id='.$poll_id;
        $this->_db->setQuery($sql);
        $vote_id = $this->_db->loadResult();
        if($vote_id)
        {
            return parent::load($vote_id);
        }
        return false;
    }
    
    function store()
    {
        jimport('joomla.utilities.date');
        if($this->ctime == '0000-00-00 00:00:00')
        {
            $date = new JDate();
            $this->ctime = $date->toMySQL();
        }
        parent::store();
    	
    }
}
?>
