<?php
/**
 * @fileID: $Id: relate_parent2.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport( 'joomla.plugin.plugin' );


class plgJoomsuite_content_fieldsRelate_parent2 extends JPlugin
{
	var $ADD_TRIGGER = 'abracadabraa';
	 
	function plgJoomsuite_content_fieldsRelate_parent2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'relate_parent2') return;

		if ( !$obj->field_value ) {
			$selected = 'y';
		} 
		else {
			$selected = $obj->field_value;
		}

		$user = & JFactory::getUser();

		if ($user->get('aid') == 2) {
			$arr = array(
				JHTML::_('select.option',  'n', JText::_( "No" ) ),
				JHTML::_('select.option',  'y', JText::_( "Yes" ) )
			);
			echo JHTML::_('select.radiolist',  $arr, "fields[".$obj->id."][tobeornottobe]", '', 'value', 'text', $selected );
		}
		else {
			echo JText::_('Related items list');
			echo '<input type="hidden" name="fields[', $obj->id, '][tobeornottobe]" value="y" />';
		}

//		
//		if (!$obj->record_id && JRequest::getInt('child_field') && JRequest::getInt('child_article')) {
//			$child_field 	= JRequest::getInt('child_field');
//			$child_article 	= JRequest::getInt('child_article');
//			
//			echo '<input type="hidden" name="fields[', $obj->id, '][child_field]" value="', $child_field,'" />';
//			echo '<input type="hidden" name="fields[', $obj->id, '][child_article]" value="', $child_article,'" />';
//		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'relate_parent2') return;
		if(!$value) return;
		
		$db = &JFactory::getDBO();
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
			
		$helper = & Relate_Fields_Helper_v1::getInstance();
		
		$debug = false;
		
		if ($debug) {
			$log = fopen('log.txt', 'a');
			fwrite($log, "------LOG STARTED----------\n");
			fwrite($log, "relate_parent::onBeforeSave\n");
		}
		
//		// Adding article as parent to provided child article
//		$childField = JRequest::getInt('child_field');
//		
//		if (isset($value['child_field'], $value['child_article'])) {
//			$value['child_field'] = intval($value['child_field']);
//			$value['child_article'] = intval($value['child_article']);
//			
//			$debug && fwrite($log, "field: {$value['child_field']}, article: {$value['child_article']}\n");
//			 
//			if ($value['child_field'] && $value['child_article']) {
//				$this->createRelation($row->id, $value['child_article'], $value['child_field'], $row->type_id);
//			}
//			
//			
//			// ---- now, add the rating to the child article ----- 
//			$child_field = & JTable::getInstance('Field', 'Table');
//			
//			if ($child_field->load($value['child_field']))
//			{
//				$curUser = & JFactory::getUser();
//				$child_params = new JParameter($child_field->params);
//				// --- Increment the rating of child article:
//				$addScore 		= $child_params->get('add_rating') && $child_params->get('num_votes', 1);
//				if ($addScore && !$curUser->guest) {
//					$howManyTimes 	= $child_params->get('num_votes', 1);
//					$howMuch 		= $child_params->get('score');
//					
//					$helper->addRating($curUser->get('id'), $value['child_article'], $howMuch, $howManyTimes);
//				}
//			}
//			
//			unset($value['child_field']);
//			unset($value['child_article']);
//		}
		
		$value = $db->getEscaped(trim($value['tobeornottobe']));
		$debug && fwrite($log, "value to save: ".$value."\n");
		
//		// If the parent "refused to be a parent", then we remove the relations here 
//		if ($value == 'n') {
//			$this->_deleteRelation($row->id, $row->type_id, $params->get('relate_field', 0));
//		}
		
		if ($debug) {
			fclose($log);
		}
		
		$helper->emptyCache($type);
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	    
		global $mainframe;
		
		if( !$field->field_value)
			return;
		if( $type != 'relate_parent2')
			return;
		if( $field->field_value != 'y' )
			return;
		
		$TTL = 1;
		// Check the nesting level (TTL)
		if (isset($field->ttl)) {
			// exit if TTL is zero or negative
			if ($field->ttl <= 0)
				return;
				
			$TTL = $field->ttl;
		}
		else {
			$TTL = $params->get('TTL', 0);
		}
		
		$TTL --;
		
		// ---------------  START: Add the new children %)) ---
		$requestData = JRequest::getVar('fields', null, 'post');
		if (isset($requestData[$field->fid]))
			$requestData = $requestData[$field->fid];
			
		$db			= &JFactory::getDBO();
		$curUser	= &JFactory::getUser();
		
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
			
		$helper = & Relate_Fields_Helper_v1::getInstance();
		
		// Test if we gonna save the new relations.
		if (isset($requestData[$this->ADD_TRIGGER]) &&
			isset($requestData['parent']) &&
			$requestData['parent'] == $field->record_id && 
			isset($requestData['children']) &&
			$requestData[$this->ADD_TRIGGER] == $this->ADD_TRIGGER)
		{
			// Save the new child now...
			JArrayHelper::toInteger($requestData['children']);
			$requestData['children'] = array_unique($requestData['children']);
			
			
			// If got any children to save:
			if (count($requestData['children'])) {
				
				$db = & JFactory::getDBO();
				$db->setQuery('SELECT type_id FROM #__js_res_record WHERE id = '.$field->record_id);
				$type_id = $db->loadResult();
				
				// Create the relation
				$this->createRelation($field->record_id, $requestData['children'], $params->get('relate_field'), $type_id);
				
				// Unset the triggering flag.
				$_POST['fields'][$field->fid][$this->ADD_TRIGGER] = 'ihopeyouwillnoteverhavethisvariableinthepostarray'.uniqid('adfdf', true);
				
				// --- Increment the rating of current article:
				$addScore 		= $params->get('add_rating') && $params->get('num_votes', 1);
				if ($addScore && !$curUser->guest) {
					$howManyTimes 	= count($requestData['children']) * $params->get('num_votes', 1);
					$howMuch 		= $params->get('score');
					
					$helper->addRating($curUser->get('id'), $field->record_id, $howMuch, $howManyTimes);
				}
				
				// clear the cache
				$helper->emptyCache($type);
			}
		}
		// ---------------  END: Add the new children %)) ---
		
		// Halt if the value is set to "n" -> do not show the child list.
		if ($field->field_value == 'n')
			return;
		
		
		$child_limit         	= $params->get( 'limit', 20 );
		if (!$child_limit)
			$child_limit = 99999; // take that! %)
		$orderby             	= $params->get( 'child_ordering', 'r.ctime ASC' );
		$bots                	= explode( ",", $params->get( 'bots', '' ) );
		$item_id             	= $params->get( 'link_itemid', JRequest::getInt( 'Itemid' ) );
		$url_add_new         	= $params->get( 'url_add_new', '' );
		$add_existing		 	= $params->get( 'add_existing', 0 );
		$invite_view_more   	= $params->get( 'invite_view_more', "See more..." );
		$invite_add_more     	= $params->get( 'invite_add_more', "Add new" );
		$jsparentrelatefield 	= $params->get( 'show_relate_field', array() );
		$child_relation_field	= $params->get( 'relate_field', 0 );
		$strict_to_user			= $params->get('strict_to_user', array());
		$return_back			= $params->get('return_back', 0); 
		$category_id			= $params->get('category_id', 0);
		
		$categoryFilter			= $params->get('allowed_cat');
		
		$addNewAccess			= $params->get('add_more_access', 1);
		if ($addNewAccess == 'none')
			$addNewAccess = false;
		else {
			$addNewAccess = $curUser->get('aid') >= $addNewAccess;
			if ($curUser->get('id') == $user)
				$addNewAccess = true;
		}
		
		settype($strict_to_user, 'array');
		$strict_to_user = in_array($curUser->get('gid'), $strict_to_user);
		
		// Public users don't have strict to user mode, to avoid errors.
		if ($curUser->guest)
			$strict_to_user = false;
		// Superadmins don't have strict to user mode
		if ($curUser->get('gid') == 25)
			$strict_to_user = false;
		
		if ($categoryFilter) {
			$categoryFilter = explode(',', $categoryFilter);
			JArrayHelper::toInteger($categoryFilter);
			$categoryFilter = array_unique($categoryFilter);
		}
		
		if ($add_existing == 'none') {
			$add_existing = false;
		}
		else {
			$add_existing = $add_existing <= $curUser->get('aid');
			if ($curUser->get('id') == $user)
				$add_existing = true;
		}

		foreach ($bots as $key => $bot)
			$bots[$key] = trim( $bot );
		$catid 	= JRequest::getInt('category_id', JRequest::getInt('section_id', 0));
		
		// Restore stuff from cache
		$info 			= null;
		$relatedRecords = null;
		$relatedFields 	= null;
		$ids			= null;
		
		
		if (empty( $child_relation_field )) {
			JError::raiseNotice("REL_P01", ucfirst($type).': '.JText::_('Please select the related field'));
			return;
		}
		
		$fromCache = $helper->getFieldCache($field, $params, $type, $user, $catid);
		
		if ($fromCache) {
			$fromCache = @unserialize($fromCache);
			
			if (isset($fromCache['info']))
				$info = $fromCache['info'];
			if (isset($fromCache['relatedRecords']))
				$relatedRecords = $fromCache['relatedRecords'];
			if (isset($fromCache['relatedFields']))
				$relatedFields = $fromCache['relatedFields'];
			if (isset($fromCache['ids']))
				$ids = $fromCache['ids'];
		}
		
		if (is_null($info)) {
			// Get the type_id for current article.
			$db->setQuery('/* RP */ SELECT type_id, client FROM #__js_res_record WHERE id = '.$field->record_id);
			$info = $db->loadObject();
		}
		
		if (is_null($ids)) {
			// Select child articles.
			$q = "/* RP */ SELECT fe.field_value_id AS id ".
				'FROM #__js_res_field_extra AS fe '.
			
			
				' WHERE fe.field_id = '.$params->get('relate_field')." AND ".
				'fe.record_id = '.$field->record_id.' AND '.
	            'fe.user_id = '. $info->type_id;
		
			$db->setQuery( $q );
			$ids = $db->loadResultArray( 0 );
		}
		
		if (is_null($relatedRecords)) {
			// Filter articles by expiration/creation dates 
			$timeWhere = $helper->_getTimeWhereSQL($params);
			// Make the client where clause
			$clientWhere = '';
	
			if ( ! $params->get('show_other_clients') ) 
			{
				if (!$helper->isShowAllCategoryClients($catid)) {
					if ($info->client == 'resource' || $info->client == '')
						$clientWhere = ' AND (r.client = "resource" OR r.client = "") ';
					else
						$clientWhere = ' AND r.client = '.$db->Quote($info->client);
				}
			}
			
			if (count($ids))
			{
				$sql = "/* RP */     SELECT r.id, r.title, r.title, rc.catid AS category_id, r.user_id "
					."\n       FROM #__js_res_record          AS r"
					."\n  LEFT JOIN #__users                  AS u    ON u.id = r.user_id"
					."\n  LEFT JOIN #__js_res_types           AS t    ON t.id = r.type_id"
					."\n  LEFT JOIN #__js_res_fields          AS f    ON f.type_id = t.id "
					."\n  LEFT JOIN #__js_res_record_values   AS v    ON v.field_id = f.id AND v.record_id = r.id"
					."\n  LEFT JOIN #__js_res_record_category AS rc   ON rc.record_id = r.id"
					."\n WHERE r.id IN (".implode(',', $ids).") AND r.published = 1 AND t.published = 1 AND "
		          	.'f.published = 1 '			
					.(is_array($categoryFilter) ? ' AND rc.catid IN ('.implode(',', $categoryFilter).') ' : '')
					.($timeWhere ? ' AND '.$timeWhere : '')
					.$clientWhere
					."\n   GROUP BY r.id"
					."\n   ORDER BY ".$orderby
					.( in_array( $_SERVER['HTTP_USER_AGENT'] , $bots ) ? '' : "\n      LIMIT 0, ".($child_limit + 1));
					
				$db->setQuery( $sql );
				$relatedRecords = $db->loadObjectList();
			}
			else
			{
				$relatedRecords = array();
			}
		}		
		
		
		$total_children = count($relatedRecords);
		if ($total_children > $child_limit)
			array_pop($relatedRecords);
		
		// This article does not have child articles.
		$noChildren = false;
		if (!count($relatedRecords)) 
			$noChildren = true;
		
		if ($noChildren) {
			$out .= JText::_('No items');
		}
		else {
			$listMode = $params->get('list_mode', 'list');
			$listThreshold = $params->get('list_threshold');
			
			if ($listThreshold && $listThreshold <= count($relatedRecords)) {
				$listMode = 'compact';
			}
			
			for ($i = 0, $count = count($relatedRecords); $i < $count; $i++) {
				$href = JRoute::_("index.php?option=com_resource&controller=article&article={$relatedRecords[ $i ]->id}&category_id=".$relatedRecords[ $i ]->category_id."&Itemid=".$item_id);
				$relatedRecords[ $i ]->link = $href;
				$relatedRecords[ $i ]->ntitle = JHTML::link($href, $relatedRecords[ $i ]->title);
			}
			
			
			
			// Prepare the fields.
			$recordIds = array();
			foreach ( $relatedRecords as $r )
				$recordIds[] = $r->id;
			
			if (is_null($relatedFields))
			{
				$relatedFields = & $helper->jsGetFieldValue($jsparentrelatefield, $recordIds, $params->get('relate_field_order', array()), $TTL, $categoryFilter);
			}
			// Render via template
			$template = $params->get('template', 'default');
			
			$listThreshold = $params->get('list_threshold');
			
			if ($listThreshold && $listThreshold <= count($relatedRecords)) {
				$template = 'compact';
			}
			
			// Set helper options for generating controls
			$helper->set('isParent', 		true);
			$helper->set('childFieldId', 	$child_relation_field);
			$helper->set('parentType', 		$info->type_id);
			$helper->set('parentRecordId',	$field->record_id);
			$helper->set('owner',			$user);
			// Children are undefined at this point
			$helper->set('childRecordId', 		false);
			
			$out .= $helper->loadTemplate($template, $relatedFields, $relatedRecords, $params, $field);
		}
		
		if (!$fromCache) {
			$toCache = array(
				'info' => 			$info,
				'relatedRecords' => $relatedRecords,
				'relatedFields' => 	$relatedFields,
				'ids' => 			$ids
			);
			
			$helper->setFieldCache($field, $params, $type, $user, $catid, serialize($toCache));
		} 
		
		// ========================================
		// Prepare field controls
		// ========================================
		
		$controls = array();

		// If the user didn't provide category id, extract it.
		if (!$category_id) {
			if( $relatedRecords ) {
				$category_id = ResHelper::getArticleSection($relatedRecords[0]->id);
			} else {
				$category_id = JRequest::getInt( 'category_id' );
			}
		}

		if ( ($invite_view_more && $total_children > count($relatedRecords)) 
			|| 
			(count($relatedRecords) && $params->get('always_show_view_more')) ) 
		{
			$controls[] = '<a class="readon" href="'.
				JRoute::_(  "index.php?option=com_resource"
					."&view=list"
					."&category_id=".$category_id
					."&child_field=".$params->get('relate_field')
					."&parent_record=".$field->record_id
					.'&view_what=related'
					.'&layout=useritems'
					."&Itemid=".$item_id
				).
			    '">'.$invite_view_more.'</a>';
		}		
		
		if ($addNewAccess && $url_add_new ) {
			$href = $url_add_new .'&child_field='.$params->get('relate_field').'&parent_article='.$field->record_id;
			$href .= '&parent_field='.$field->fid;
			
			if ($return_back) {
				$uri = & JURI::getInstance();
				$href .= '&redirect='.base64_encode($uri->toString());
				if (JRequest::getString('view') == 'list')
					$href .= '#flag'.$field->record_id;
			}
			$controls[] = '<a class="readon" href="'. JRoute::_($href).'">'.$invite_add_more.'</a>';
		}
		
		if ($add_existing) {
			$uid = uniqid('relation');
			ob_start();
			?>
			<script>
			// The "add existing" popup. 
			var popupChik<?php echo $uid; ?> = null;
			var parent<?php echo $uid; ?> = null;
			// The popup state [0, 1] = [hidden, visible]
			var popupChikState<?php echo $uid; ?> = 0;
			
			function popup<?php echo $uid; ?>(who) {
				if (!popupChik<?php echo $uid; ?>) {
					// Create the popup if not exists 
					var d = document.createElement('div');
					d.id = 'add_existing_popup_<?php echo $uid; ?>';
					// Set the HTML popupData 
					d.innerHTML = '<img src="<?php echo JURI::root(); ?>plugins/joomsuite_content_fields/images/relate_fields/loading.gif" />';
					
					rel_par_arrangeExistingPopup(who, d);
					
					popupChik<?php echo $uid; ?> = d;
					parent<?php echo $uid; ?> = who;

					// Load the Related records that can be added.
					xajax_jsCallPlugin(
							'joomsuite_content_fields', 
							'relate_parent2', 
							'onXajaxGetExistingRecords', 
							[
								'<?php $uri = & JURI::getInstance(); echo addslashes($uri->toString()); ?>', <?php echo $field->id?>, 
								d.id, 'popup<?php echo $uid; ?>(null);', 'rel_par_xajaxCallback<?php echo $uid; ?>();'
							]
					);
				}
				
				// Toggle the PoPuP:
				if (popupChikState<?php echo $uid; ?> == 1)
					popupChik<?php echo $uid; ?>.style.display = 'none';
				else 
					popupChik<?php echo $uid; ?>.style.display = 'block';

				popupChikState<?php echo $uid; ?> = 1 - popupChikState<?php echo $uid; ?>;
			}

			function rel_par_xajaxCallback<?php echo $uid; ?>() {
				rel_par_arrangeExistingPopup(parent<?php echo $uid; ?>, popupChik<?php echo $uid; ?>);
			}
			
			function rel_par_arrangeExistingPopup(parent, target) {
				// p = The element being clicked.
				var p = parent;
				var top = 0, left = 0;
				for ( ; p; p = p.offsetParent ){
			        top  += p.offsetTop;
			        left += p.offsetLeft;
				}
				
				top -= parent.offsetHeight + 5;
									
				document.body.appendChild( target );
				target.style.zIndex = '99999';
				target.style.position = 'absolute';
				target.style.background = '';
				
				top -= target.offsetHeight;
				left += parent.offsetWidth;
				left -= target.offsetWidth;
				
				target.style.top = top + 'px';
				target.style.left = left + 'px';
			}
			
			</script>
			<a class="readon" href="javascript:void(0);" onclick="popup<?php echo $uid; ?>(this);" >
			<?php echo JText::_($params->get('add_existing_label', 'Add existing...')); ?></a>
			<?php
			$controls[] = ob_get_contents();
			ob_end_clean();
		}
		
		if (count($controls)) {
			$out .= '<table align="right"><tr><td nowrap="nowrap">';
			$out .= implode('</td><td nowrap="nowrap">', $controls);
			$out .= '</td></tr></table>';
		}
	}
	
	function onXajaxGetExistingRecords(&$objResponse, $url, $recordValueId, $targetElementId, $onClick, $callBack) {
			$db = & JFactory::getDBO();
			$curUser = & JFactory::getUser();
		
			$query = "SELECT ".
				" v.id, v.record_id, f.id as fid, f.params, f.type
				FROM 			#__js_res_record_values as v " .
				' LEFT JOIN 	#__js_res_fields AS f 			ON f.id = v.field_id' .
				' WHERE v.id = ' . $recordValueId;
			
			$db->setQuery($query);
			$field = $db->loadObject();
			
			$params 		= new JParameter($field->params);
			$strict_to_user	= $params->get('strict_to_user', 0);
			$curUser 		= & JFactory::getUser();
			
			settype($strict_to_user, 'array');
			$strict_to_user = in_array($curUser->get('gid'), $strict_to_user);
//			// Public users don't have strict to user mode, to avoid errors.
//			if ($curUser->guest)
//				$strict_to_user = false;
			// Superadmins don't have strict to user mode
			if ($curUser->get('gid') == 25)
				$strict_to_user = false;
			
			// Get the type_id for current article.
			$db->setQuery('SELECT type_id FROM #__js_res_record WHERE id = '.$field->record_id);
			$type_id = $db->loadResult();
		
            $sql = "     SELECT r.id"
                ."\n       FROM #__js_res_record          AS r"
                ."\n  LEFT JOIN #__js_res_types           AS t    ON t.id = r.type_id"
                ."\n  LEFT JOIN #__js_res_fields          AS f    ON f.type_id = t.id "
                .'    LEFT JOIN #__js_res_field_extra AS fe ON r.id = fe.field_value_id '
                ."\n WHERE r.published = 1 AND t.published = 1 AND ".
                'fe.field_id = '.$params->get('relate_field')." AND ".
                'fe.record_id = '.$field->record_id.' AND '.
                'f.published = 1 AND '.
                'fe.user_id = '. $type_id. ' '
                ."\n   GROUP BY r.id"
                ."\n   ORDER BY r.id";
                
            $db->setQuery( $sql );
            $ids = $db->loadResultArray( 0 );
            
            // Filter articles by expiration/creation dates 
            require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
            $helper = & Relate_Fields_Helper_v1::getInstance();
            
            // Make the client where clause
			$clientWhere = '';
			$catid 	= 0;
			
			$q = 'SELECT catid FROM #__js_res_record_category WHERE record_id = '.$field->record_id.' LIMIT 1';
			$db->setQuery( $q );
			$catid = $db->loadResult();

			if ( ! $params->get('show_other_clients') )
			{
				if ($catid && !$helper->isShowAllCategoryClients($catid)) {
					// Get the record client
					$q = 'SELECT client FROM #__js_res_record WHERE id = '.$field->record_id;
					$db->setQuery( $q );
					$client = $db->loadResult();
					
					if ($client == 'resource' || $client == '')
						$clientWhere = ' AND (r.client = "resource" OR r.client = "") ';
					else
						$clientWhere = ' AND r.client = '.$db->Quote($client);
				}
			}
            
			$timeWhere = $helper->_getTimeWhereSQL($params);
            
            $sql = "SELECT r.id, r.title"
                ."\n       FROM #__js_res_record          AS r"
                ."\n  LEFT JOIN #__js_res_types           AS t    ON t.id = r.type_id"
                ."\n  LEFT JOIN #__js_res_fields          AS f    ON f.type_id = t.id "
                ."\n  LEFT JOIN #__js_res_record_values   AS v    ON v.field_id = f.id AND v.record_id = r.id"
                ."\n  LEFT JOIN #__js_res_record_category AS rc   ON rc.record_id = r.id"
                ."\n WHERE r.published = 1 AND t.published = 1 AND ".
                'f.id = '.$params->get('relate_field').
                ($timeWhere ? " AND ".$timeWhere : '').
                $clientWhere.
                ' AND f.published = 1 '.
                ($strict_to_user ? 'AND r.user_id = '.$curUser->get('id') : '').
                ((is_array($ids) && count($ids)) ? ' AND r.id NOT IN ('.implode(',', $ids).') ' : ' ')
                ."\n  GROUP BY r.id"
                .' ORDER BY r.title';
            
            $db->setQuery( $sql );
            
            $result = $db->loadObjectList();
            
            
            
            // Let's add some javascript magic here..
            ob_start();
           
            ?>
            <form action="<?php echo $url; ?>" method="post">
                <p><?php echo JText::_('Select'), ':'; ?></p>
                <div style="clear:both"></div>
                <?php if (count($result)) : ?>
                    <select size="<?php echo min($params->get('add_existing_select_size', 10), count($result)); ?>" name="fields[<?php echo $field->fid; ?>][children][]" multiple="multiple">
                    <?php
                    foreach ($result as $r) {
                        echo '<option value="', $r->id, '">', $r->title,'</option>';
                    }
                    // Enable "Add" button
                    $disableAdd = false;
                    ?>
                    </select>
                <?php else: ?>
                    <b><?php echo JText::_('No items to add'); ?></b>
                    <?php
                        // Disable "Add" button 
                        $disableAdd = true; 
                    ?>
                <?php endif; ?>
                <br />
                <br />
                <input type="hidden" name="fields[<?php echo $field->fid; ?>][<?php echo $this->ADD_TRIGGER; ?>]" value="<?php echo $this->ADD_TRIGGER; ?>" />
                <input type="hidden" name="fields[<?php echo $field->fid; ?>][parent]" value="<?php echo $field->record_id; ?>" />
                <input type="hidden" name="fields[<?php echo $field->fid; ?>][parent_field]" value="<?php echo $field->fid; ?>" />
                <div>
                    <div style="float:left">
                        <input <?php if ($disableAdd) echo ' disabled="disabled" '; ?>type="submit" class="button" value="<?php echo JText::_('Add'); ?>" />
                    </div>
                    <div style="float:right">
                        <input type="button" class="button" value="<?php echo JText::_('Close'); ?>" onclick="<?php echo $onClick; ?>" />
                    </div>
                </div>
            </form>
            <?php
            $popupData = ob_get_clean();
            
            $objResponse->assign($targetElementId, "innerHTML", $popupData);
            if ($callBack)
            	$objResponse->script($callBack);
	}
	
	/**
	 * Creates relations between articles. Updates both #__js_res_field_extra
	 * and approriate child field value.
	 *
	 * @param int $parent_article
	 * @param mixed $child_article Id of child article, or an array of ids.
	 * @param int $child_field
	 * @param int $type Parent article type id
	 */
	function createRelation($parent_article, $child_article, $child_field, $type) {
		$db = & JFactory::getDBO();
		
		$debug = false;
		
		if ($debug) {
			$log = fopen('relation.txt', 'a');
			fwrite($log, '---- LOG START ----'."\n");
			ob_start();
			echo '$parent_article, $child_article, $child_field, $type', "\n";
			var_dump($parent_article, $child_article, $child_field, $type);
			fwrite($log, ob_get_clean()."\n");
		}
		
		if ($child_field && $child_article && $parent_article && $type) {
			
			if (is_array($child_article))
				$child_article = array_unique($child_article);
			else
				$child_article = array($child_article);
			
			JArrayHelper::toInteger($child_article);
			
//			$q = '/* RP */ SELECT COUNT(*) '.
//				'FROM #__js_res_record_values '.
//				'WHERE record_id IN ('.implode(',', $child_article).') '.
//				'AND field_id = '.$child_field;
			
			$q = '/*RP*/ SELECT COUNT(*) '.
				'FROM '. 
							'`#__js_res_record` r '.
				'INNER JOIN  `#__js_res_fields` f ON f.type_id = r.type_id '.
				'WHERE '.
				'r.id IN ('.implode(',', $child_article).') AND f.id = '.(int)$child_field;		
			
			$db->setQuery( $q );
			$count = $db->loadResult();
			
			$debug && fwrite($log, "For query: ".$db->getQuery()."\n");
			$debug && fwrite($log, "Count = $count\n");
			
			// If the child article(s) exist, create the relation.
			if ($count && $count == count($child_article)) {
				// Insert the new relation.
				$q = '/* RP */ INSERT INTO #__js_res_field_extra '.
					'(`user_id`, `ref_id`, `ctime`, `ip`, `value`, `field_id`, `field_value_id`, `record_id`) VALUES ';
				
				$values = array();
				foreach ($child_article as $a) {
					$values[] = '('.$type.', "", NOW(), "'.$db->Quote($_SERVER['REMOTE_ADDR']).'", "", '.
					$child_field.', '.$a.', '.$parent_article.')';
				}
				
				$q .= implode(',', $values);
				
				$db->setQuery( $q );
				$debug && fwrite($log, "Query = ".$db->getQuery()."\n");
				
				$db->query();
				
				// Update the child field value, put the parent article id there.
				// Note: smart update here... __PLG_RC_DUMB_
				$q = "/* RP */ UPDATE `#__js_res_record_values` b SET b.field_value = ".
						"TRIM(LEADING ',' FROM ".
							"REPLACE(".
								"CONCAT(b.field_value, IF (CHAR_LENGTH(b.field_value) > 0, ',".$parent_article."', '".$parent_article."') ), ".
								' "__PLG_RC_DUMB_", "")'.
						")".
					'WHERE b.field_id = '.$child_field.' AND b.record_id IN ('.implode(',', $child_article) .') AND NOT LOCATE(",'.$parent_article.',", CONCAT(",", b.field_value, ","))';
				$db->setQuery( $q );
				$debug && fwrite($log, "Query = ".$db->getQuery()."\n");
				$db->query();
				
				// Everything is OK now..
				$debug && fclose($log);
				return true;
			}
		}
		$debug && fclose($log);
		return false;
	}

	/**
	 * Deletes relation between parent articles
	 * @param $parentId
	 * @param $parentType
	 * @param $childFieldId
	 * @return unknown_type
	 */
	function _deleteRelation($parentId, $parentType, $childFieldId) {
		$parentId 		= (int)$parentId;
		$parentType 	= (int)$parentType;
		$childFieldId 	= (int)$childFieldId;
		
		// Delete the relations for parent.
		$q = '/* RP */ DELETE FROM #__js_res_field_extra WHERE user_id = '.$parentId.' AND ref_id="" AND value=""  AND field_id = '.$childFieldId.' AND record_id = '.$parentId;
		
		$db = & JFactory::getDBO();
		
		$db->setQuery( $q );
		$db->query();
		
		
		// Update child record values.
		$q = ' /* RP */ UPDATE #__js_res_record_values b '.
		' SET b.field_value = TRIM(BOTH "," FROM REPLACE(REPLACE(b.field_value, "'.$parentId.'", ""), ",,", ",")) '.
		' where b.field_id = '.$childFieldId.' AND locate("'.$parentId.'", b.field_value)';
		
		$db->setQuery( $q );
		$db->query();
	}
}