<?php
/**
 * @fileID: $Id: relate_parent3.php 7799 2012-02-13 06:44:52Z kostya $
 * @changedDate: $LastChangedDate: 2012-02-13 13:44:52 +0700 (Пн, 13 фев 2012) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );


class plgJoomsuite_content_fieldsRelate_parent3 extends JPlugin
{
	var $ADD_TRIGGER = 'abracadabraa';
	 
	function plgJoomsuite_content_fieldsRelate_parent3( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper3.php';
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'relate_parent3') return;
		
		if( !$params->get('relate_field') || !$params->get('parent_section') ) {
			echo JText::_( 'This field is not configured. Please set parent type and parent section in params of this field' );
			return;
		}
		$db = &JFactory::getDBO();
		if($parent = JRequest::getString('related'))
		{
			$def[] = $parent;
		}
		else
		{
			$def = JRequest::getVar('fields', array(), 'default', 'array');
			if(key_exists($obj->id, $def)) {
				$def = $def[$obj->id];
			}
			else
			{
				$sql = "SELECT record_id FROM #__js_res_record_values WHERE field_value LIKE '%,{$obj->record_id},%' AND field_id = ".$params->get('relate_field');
				$db->setQuery($sql);
				$def = $db->loadResultArray();
			}
			settype($def, 'array');
			$def = $this->trimArray($def); 
		}
		$link = '';
		$app = JFactory::getApplication();
		if( $app->isAdmin()){
			$link .= '../';
		}
		$link .= 'index2.php?option=com_resource&view=utility&layout=relation&article='.$obj->record_id.'&field='.$obj->id./*'&category='.$params->get('parent_section').*/'&format=html';
		$link = MERoute::_($link);
		echo "<span class=\"readonbox\">".
		//<a class=\"readon relate_child3_add_existing{$obj->id}\" rel=".$obj->record_id.'::'.$obj->id." href=\"".$link."\">"
		"<a class=\"modal readon _parent3_add_existing{$obj->id}\" onclick=\"$('relatedItems{$obj->id}').empty()\" rel=\"{handler: 'iframe', size: {x: 800, y: 600}}\" href=\"".$link."\">"
			.JText::_($params->get('add_existing_label', 'Attach Existing'))
			."</a></span>";
		echo '<div style="clear:both;height:5px"></div>';
		echo '<div id="relatedItems'.$obj->id.'">', 
			( ! $def) ? JText::_('No items selected') : '', 
			'</div><div style="clear:both"></div>';
		
		JHTML::_('behavior.modal');
		$document = & JFactory::getDocument();
			
		$document->addScriptDeclaration("if (!window.relatedChildFunctions)	window.relatedChildFunctions = {};");
		
		/// Generic function gateway
		$document->addScriptDeclaration(
			"function onRelatedArticlesSelected(articleId, fieldId, relatedIds, titles, params) {
				if (!relatedIds) return;
				window['relatedChildFunctions_' + fieldId](articleId, fieldId, relatedIds, titles, params);
			}"
		);
		
		$document->addScriptDeclaration(
			"
			function relatedChildFunctions_{$obj->id}(articleId, fieldId, relatedIds, titles, params) 
			{
				for (var i = 0; i < relatedIds.length; i++) {
					var outer = new Element('span');
					outer.setStyle('float', 'left');
					outer.addClass('article_selector_span');
					outer.setHTML(titles['article' + relatedIds[ i ]]);
					var input = new Element('input');
					input.setAttribute('name', 'fields[$obj->id][vals][]'); 
					input.setAttribute('type', 'hidden'); 
					input.setAttribute('value', relatedIds[i]); 
					input.inject(outer);
					var div = new Element('div');
					if(typeof(params['article' + relatedIds[ i ]]) != 'undefined'){
						var hparams = new Element('input');
						hparams.setProperties({'name':'fields[$obj->id][params][' + relatedIds[i] + ']', 'type':'text', 'value':params['article' + relatedIds[ i ]]}).addClass('inputbox').inject(div);
					}
					var a = new Element('a', {href: 'javascript:void(0);'}).setHTML('".addslashes(JHTML::image(JURI::root().'components/com_resource/images/f-c2.png', JText::_('Remove', true)))."').inject(outer);

					a.addEvent('click', function() {
						this.getParent().remove();
					});
					outer.inject($('relatedItems$obj->id'));
					div.inject(outer);
				}
			}"
		);
		
		
		if ($def) {
			$ids = implode(', ', $def);
			
			$db->setQuery('SELECT id, title FROM #__js_res_record WHERE id IN ('.$ids.')');
			$titles = $db->loadObjectList('id');
			$obj->fparams? $fparams = unserialize($obj->fparams): $fparams = array();
			
			$t = array();
			$p = array();
			foreach ($def as $id) {
				if (!empty($titles[ $id ]))
					$t [] = '"article'.$id.'": "'.addslashes($titles[ $id ]->title).'"';
				if($params->get('relate_tags', 0))
				{
					isset($fparams[ $id ])? $fparam = addslashes($fparams[ $id ]): $fparam='';
					$p [] = '"article'.$id.'": "'.$fparam.'"';
				}
			}
			
			$t = '{'.implode(', ', $t).'}';
			$p = '{'.implode(', ', $p).'}';
			$document->addScriptDeclaration(
				"window.addEvent('domready', function() {
					relatedChildFunctions_{$obj->id}($obj->record_id, $obj->id, [$ids], $t, $p);
				});"
			);
		}
	}
	
	function trimArray($def)
	{
		//$def = JArrayHelper::toInteger($def);
		settype($def, 'array'); $out = array();
		foreach($def as $id)
		{
			if((int)$id <= 0) continue;
			$out[] = $id;
		}
		return $out;
	}
	function onDeleteRecords($recordIds)
    {
    	$db = &JFactory::getDBO();
    	
    	settype($recordIds, 'array');
    	foreach ($recordIds AS $record)
    	{
	    	$sql = "SELECT rv.* FROM #__js_res_record_values AS rv 
	    	LEFT JOIN #__js_res_fields AS f ON f.id = rv.field_id
	    	WHERE rv.field_value LIKE '%,{$record},%' AND f.`type` = 'relate_child3'";
	    	$db->setQuery($sql);
			$result = $db->loadObjectList();
			foreach ($result as $row) {
				$ids = explode(',', $row->field_value);
				$ids = $this->trimArray($ids);
				$ids = array_unique($ids);
				unset($ids[array_search($record, $ids)]);
				
				$sql = "UPDATE #__js_res_record_values SET field_value = ',".implode(',', $ids).",' WHERE id = ".$row->id;
				$db->setQuery($sql);
				$db->query(); 
			}
    	}
    }
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'relate_parent3') return;
		settype($value['vals'], 'array');
		settype($value['params'], 'array');
		JArrayHelper::toInteger($value['vals']);
		JArrayHelper::toString($value['params']);
		$vals = $this->trimArray($value['vals']);
		$vals = array_unique($vals);
		$pars = array_unique($value['params']);
		if($vals)
		{
    		$child = $params->get('relate_field');
    		
    		$db = &JFactory::getDBO();
    		
    		// 
    		$sql = "SELECT id FROM #__js_res_record_values WHERE field_value LIKE '%,{$row->id},%' AND field_id = ".$child;
    		$db->setQuery($sql);
    		$r = $db->loadResultArray();
    		
    		$diff = array_diff($r, $vals);
    		if(count($diff)){
    			$sql = "UPDATE #__js_res_record_values SET field_value = REPLACE(field_value,',{$row->id},','') WHERE id IN (".implode(',', $diff).")";
    			$db->setQuery($sql);
    			$db->query();
    		}
		    
			$sql = "UPDATE #__js_res_record_values SET field_value = CONCAT(field_value , ',{$row->id},') WHERE record_id IN (".implode(',', $vals).") AND field_id = ".$child;
			$db->setQuery($sql);
			$db->query();
		} 

		$value = 1;
		return $pars;
	}
	
	function onFilter($out, $type)
	{
		if($type != 'relate_parent3') return;
		$out = true;
	}
	
	function onFilterWornLabel(&$label, &$filter, $value, &$params, $category_id)
	{
		
		if ($filter->type != 'relate_parent3')
			return;
		
		$value = (int)$value;
		if ( ! $value)
			return; 
			
		$record = & JTable::getInstance('Record', 'Res');
		if ( $record->load($value) ) 
		{
			$label = $record->title;
		}
	}
	
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		static $results = array();
		
		if( $type->type != 'relate_parent3' ) return;
		if( !$value ) return;
		
		$key = $filter->id.$type->type.$value;
		if (isset($results[$key])) {
			$sql = $results[$key];
			return;
		}
		
		
		$db = & JFactory::getDBO();
		$value = (int)$value;
		$params = new JParameter($filter->params);
		if(!$params->get('relate_field'))
		{
			JError::raiseNotice(1542, JText::_('Error: child field not set in parent field parameters'));
		}
		
		$sql = "SELECT field_value FROM #__js_res_record_values WHERE record_id = {$value} AND field_id = ".(int)$params->get('relate_field', 0);
		$db->setQuery($sql);
		$ids = explode(',' , $db->loadResult());
		$ids = $this->trimArray($ids);
		JArrayHelper::toInteger($ids);
		$ids[] = 0;
		if ($ids)
		{
			$results[$key] = 'r.id IN ('.implode(',', $ids).')';
		}
		
		$sql = $results[$key];
	}
	
	function typeIdByField($field)
	{
		$db	= &JFactory::getDBO();
		$sql = "SELECT type_id FROM #__js_res_fields WHERE id = ".$field;
		$db->setQuery($sql);
		return $db->loadResult();
	}
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'relate_parent3') return;
		if($field->field_value != 1) return;
			
		//$forceListView = JRequest::getInt('hide_parent_field');
			
		global $mainframe;
		
		$params = new JParameter($field->params);
		$child_relation_field = $params->get('relate_field', 0);
		$controls = array();
		
		if (empty( $child_relation_field )) {
			JError::raiseNotice(1025, ucfirst($field->type).': '.JText::_('Please select the related field'));
			return;
		}
		
		$db		= &JFactory::getDBO();
		$user 	= & JFactory::getUser();
		$params = new JParameter($field->params);
		
		$aid = JRequest::getInt('relatedArticle');
		$fid = JRequest::getInt('relatedField');
		$iid = explode(',', JRequest::getVar('relatedIds'));
		$param_vals = explode(',', JRequest::getVar('paramVals'));
		
		if($aid == $record->id && $fid == $field->fid )
		{
			
			settype($iid, 'array');
			$iid = $this->trimArray($iid);
			settype($param_vals, 'array');
			if (count($param_vals) && !empty($param_vals[0])){
				$param_vals = array_combine($iid, $param_vals);
				$sql = "UPDATE #__js_res_record_values SET params = '".serialize($param_vals)."' WHERE id = $field->id";
				$db->setQuery($sql);
				$db->query();
			}
			
			$sql = "SELECT id FROM #__js_res_record_values WHERE field_value LIKE '%,{$record->id},%' AND field_id = ".$child_relation_field;
			$db->setQuery($sql);
			$r = $db->loadResultArray();
			//that's something stupid for now left it as it is but have to fix
			$diff = array_diff($r, $iid);
			if(count($diff)){
				$sql = "UPDATE #__js_res_record_values SET field_value = REPLACE(field_value,',{$record->id},','') WHERE id IN (".implode(',', $diff).")";
				$db->setQuery($sql);
				$db->query();
			}
			if(!empty($iid)){	
				$sql = "UPDATE #__js_res_record_values SET field_value = CONCAT(field_value , ',".$record->id.",') WHERE record_id IN (".implode(',', $iid).") AND field_id = ".$child_relation_field;
				$db->setQuery($sql);
				$db->query();
			}
			
			$mainframe->enqueueMessage(JText::_('Attachment Successfull'));
		}
		
		$sql = "SELECT * FROM #__js_res_record_values WHERE field_value LIKE '%,{$record->id},%' AND field_id = ".$child_relation_field;
		$db->setQuery($sql);
		$records = $db->loadObjectList();
		$ids = array();
		if(!is_array($records))
		{
			settype($records, 'array');
		}
		foreach ($records AS $item)
		{
			$ids[$item->record_id] = $item->record_id;
		}
		
		
		if($ids)
		{
			if(JRequest::getVar('view') == 'list' || $params->get('full_list_type') == 'titles')
			{
				$sql = "SELECT * FROM #__js_res_record WHERE id IN(".implode(',', $ids).") ORDER BY ".$params->get('intro_orderby', 'ctime DESC')." LIMIT ".$params->get('limit_intro');
				$db->setQuery($sql);
				$records = $db->loadObjectList();
				
				$params->set('filter_linkage', 2);
				$params->set('category_id', $category);
				
				$li = array(); $i = 0;		
				foreach ($records AS $item)
				{
					$li[$i]->id = $item->id;
					$li[$i]->link = ResHelper::cleanFilterValue(
						JHTML::link(
							MEUrl::link_record(
								$item, 
								$params->get('parent_section')
							), 
							$item->title
						), 
						base64_encode($item->id), 
						$field, 
						$params,
						$record
					);
					$i++;
				}
				
				$helper = FieldRelateHelper::getInstance();
				
				$helper->set('isParent', 		true);
    			$helper->set('childFieldId', 	$child_relation_field);
    			$helper->set('parentRecordId', 	$field->record_id); 
    			$helper->set('parentType', 		$this->typeIdByField($child_relation_field));
    			
				if(count($li) <= 0 )
					$out = JText::_('No items');
				else
					$out = $helper->getDecoratedList($li, $params);
			}
			else 
			{
				require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php';
	
				$options = array();
				$options['limit'] 		= $params->get('limit_full');
				$options['category'] 	= $params->get('parent_section');
				$options['user_id'] 	= 0;
				$options['view_what'] 	= 0;
				$options['client'] 		= 'module';
				if ($params->get('relate_tags', 0)) 
					$options['relate_tags'] 		= $field->vparams;
				$options['records_mode'] = 2;
				if ($params->get('full_template')) 
					$options['template'] = $params->get('full_template');
				if ($params->get('full_orderby')) 
					$options['order'] = $params->get('full_orderby', 'r.title ASC');
					
				$where = array('r.id IN ('.implode(',', $ids).')');
				$join = array();
	
				$a = null;
				$b = null;
				
				$list = MightyResourcesApi::getRecordList($options, $where, $join, $a, $b);
//				var_dump($list);
				if (count($list[0]) <= 0 )
					$out = JText::_('No items');
				else
					$out = $list[1];
			}
			if(
				((JRequest::getInt('article')) && $params->get('full_show_readmore') && ($params->get('limit_full') < count($ids))) 
				|| ((JRequest::getVar('view') == 'list') && $params->get('intro_show_readmore') && ($params->get('limit_intro') < count($ids)))
			)
			{
				$readMoreType = JRequest::getVar('view') == 'list' ? $params->get('intro_show_readmore') : $params->get('full_show_readmore');
				$link = '';
				switch ($readMoreType)
				{
					case 2: // Filter
						$q = 'select f.id, f.params, f.title FROM #__js_res_fields f WHERE f.id = '.$child_relation_field;
						$db->setQuery($q, 0, 1);
						$parent_field = $db->loadObject();
						
						if ($parent_field)
						{
							$pf_params = new JParameter($parent_field->params);
							if($pf_params->get('filter_enable'))
							{
								$filter = '&filter'.$parent_field->id.'[]='.base64_encode($record->id);
								$link = MEUrl::link_list($params->get('parent_section'));
								$link = MERoute::_($link.$filter);
							}
							else
							{
								JError::raiseNotice(1010, JText::_('Error: Cannot create "Show All..." link. Related field have not been set as filter').' ['.JText::_('Field').': '.$parent_field->title.' ('.$parent_field->id.')]');
							}
						}
					break;
					
					case 1:
						$link = MEUrl::link_list($params->get('parent_section'), array('view_what' => 'related'));
						$link = MERoute::_($link.'&parent='.$record->id.'&field='.$field->fid);
					break;
				}
				if($link) $controls[] .= " <span class=\"readonbox\"><a class=\"readon\" href=\"{$link}\">".JText::_($params->get('invite_view_more', "Show All..." ))." (".count($ids).") </a></span> ";
			}
		}
		
		if($user->get('aid') >= $params->get('add_more_access') || MEAccess::isAdmin() || MEAccess::isAuthor($record->user_id, ($params->get('add_more_access') == 5)))
		{
			$link = 'index.php?option=com_resource&controller=article'
				.'&type_id='.$this->typeIdByField($child_relation_field)
				.'&view=article&layout=form&related='.$record->id;
			
			
			$forcedCategory = $params->get('force_category');
			settype($forcedCategory, 'array');
			if(@$forcedCategory[0])
			{
				$link .= '&category_id='.$forcedCategory[0];
				$forcedCategory = implode(',', $forcedCategory);
				if($forcedCategory) $link .= '&hc='.base64_encode($forcedCategory);
			}
			else
			{
				$link .= '&category_id='.$params->get('parent_section');
			}
			
			$link .= '&Itemid='.MEUrl::itemid(null, $params->get('parent_section'));
			
			$uri = JFactory::getURI();
			$uri->delVar('lastid');
			$url = $uri->toString();
			$link .= '&redirect='.base64_encode($url);
			
			$controls[] = " <span class=\"readonbox\"><a class=\"readon\" href=\"".MERoute::_($link)."\">".JText::_($params->get('invite_add_more', "Add New"))."</a></span> ";
		}
		
		if ($params->get('strict_to_user'))
		{
			$strictToUser 	= $params->get('strict_to_user', array());
			settype($strictToUser, 'array');
			
			if ( in_array($user->get('gid'), $strictToUser) ){
				if ( $record->user_id == $user->get('id') )
					$strictToUser = true;
				else
					$strictToUser = false;
			} else {
				$strictToUser = true; 
			}
			
			// Superadmins don't have strict to user mode
			if ($user->get('gid') == 25)
				$strictToUser = true;
		}
		else
		{
			$strictToUser = true;
		}
		
		if(($user->get('aid') >= $params->get('add_existing') || MEAccess::isAdmin()) && $strictToUser == true )
		{
			$link = '';
			$app = JFactory::getApplication();
			if( $app->isAdmin()){
				$link .= '../';
			}
			$link .= 'index2.php?option=com_resource&view=utility&layout=relation&article='.$record->id.'&field='.$field->fid.'&format=html';
//			if ($category != $params->get('parent_section'))
//				$link .= '&category='.$params->get('parent_section');
			$link = MERoute::_($link);
			
			$controls[] = "<div class=\"readonbox\">".
				//"<a class=\"modal readon relate_parent3_add_existing{$field->fid}\" rel=" .$record->id.'::'.$field->fid." href=\"".$link."\">"
				"<a class=\"modal readon\" rel=\"{handler: 'iframe', size: {x: 800, y: 600}}\" href=\"".$link."\">"
				.$params->get('add_existing_label', JText::_('Attach Existing'))
				."</a></div>";
		}
		$out .= implode(' ', $controls);
		
		JHTML::_('behavior.modal');
		
		$uri = JFactory::getURI();
		
		$document = & JFactory::getDocument();
		
		$document->addScriptDeclaration(
			'function onRelatedArticlesSelected(articleId, fieldId, relatedIds, titles, params) {
				/*if ( ! relatedIds || ! relatedIds.length )
					return;*/
				
				var url = \''.addslashes($uri->toString()).'\';
				
				var form = new Element(\'form\', {action: url, method: \'post\'});
				
				new Element(\'input\', {name: \'relatedArticle\', type: \'hidden\', value: articleId}).inject(form);
				new Element(\'input\', {name: \'relatedField\', type: \'hidden\', value: fieldId}).inject(form);
				new Element(\'input\', {name: \'relatedIds\', type: \'hidden\', value: relatedIds.join(\',\')}).inject(form);
				var paramVals = [];
				$each(params, function(el){
					paramVals.push(el);
				});
				if(paramVals.length)
					new Element(\'input\', {name: \'paramVals\', type: \'hidden\', value: paramVals.join(\',\')}).inject(form);
				document.body.appendChild(form);
				form.submit();
			}'
		);
	}
	
}