<?php
/**
 * @fileID: $Id: table.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access' );

$li_class = $this->get ( 'relatedRecordCssClass' );
$i 		= 1;
$cnt 	= 0;

echo '<table width="100%" cellspacing="0" cellpadding="5" border="0">';
echo '<tr class="sectiontableheader">';
echo '<td>';
echo JText::_ ( 'Title' );
echo '</td>';

foreach ( $relatedFields as $rec ) {
	if (count ( $rec ) >= $cnt) {
		$cnt = count ( $rec );
		$mrec = $rec;
	}
}

if ($mrec) {
	foreach ( $mrec as $f ) {
		echo '<td>';
		echo $f ['field']->title;
		echo '</td>';
	}
}
echo '</tr>';

// The number of TD's we need to fill up the table with
$maxNumberOfTD = -1;
foreach ( $relatedRecords as $key => $record ) 
{	
	$fields = empty($relatedFields[$record->id]) ? array() : $relatedFields[$record->id];
	
	if (count($fields) > $maxNumberOfTD)
		$maxNumberOfTD = count($fields);
}


foreach ( $relatedRecords as $key => $record ) {
	$recordId = $record->id;
	$fields = $relatedFields [$record->id];
	$hasFields = is_array ( $fields ) && count ( $fields );
	$title = $hasFields && $params->get ( 'value_as_link', 0 ) ? $record->title : $record->ntitle;
	$i = 1 - $i;

	echo '<tr class="sectiontableentry' . ($i + 1) . '">';
	echo '<td class="', $li_class, '" rel="', $record->id, '">';
	echo '<ul><li style="background:none; padding:0; width:70px;" class="', $li_class, '" rel="', $record->id, '">';
	echo $title;
	
	$this->includeEventsJavascript ( $params, $record );
	
	// "Edit | Remove from list" controls
	$controlButtons = $this->getControlButtons ( $record, $params );
	if ($controlButtons)
		echo '<br>' . $controlButtons;
	echo '</li></ul>';
	echo '</td>';
	
	if ($hasFields) 
	{
		$counter = 0;
		
		foreach ( $fields as $f ) {
			echo '<td>';
			if ($params->get ( 'value_as_link', 0 ))
				echo '<a href="' . $record->link . '">' . $f ['text'] . '</a>';
			else
				echo $f ['text'];
			echo '</td>';
			
			$counter++;
		}
		
		//  Fill the empty cells with &nbsp :)
		if ($counter < $maxNumberOfTD)
		{	
			echo '<td colspan="'.($maxNumberOfTD - $counter).'">&nbsp;</td>';
		}
	}
	echo '</tr>';
}

echo '</table>';