<?php
/**
 * @fileID: $Id: share.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsShare extends JPlugin
{
    function plgJoomsuite_content_fieldsShare( &$subject, $params )
    {
        parent::__construct( $subject, $params );
    }
    function onRenderField(&$obj, &$params, $type)
    {
        if($type != 'share') return;
        $access = $params->get('access', 0);
        $user = JFactory::getUser();

        if( !$obj->field_value )
        {
            $selected = 'y';
        } else
        {
            $selected = $obj->field_value;
        }

        if( $user->aid >= $access)
        {
            $arr = array(
                    JHTML::_('select.option',  'n', JText::_( "No" ) ),
                    JHTML::_('select.option',  'y', JText::_( "Yes" ) )
            );
            echo JHTML::_('select.radiolist',  $arr, "fields[".$obj->id."]", '', 'value', 'text', $selected );
        }
        else
            echo '<input type="hidden" name="fields['.$obj->id.']" value="'.$selected.'">';

    }
    function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
    {
        if($type != 'share') return;
        if(!$value) return;
    }
    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
        if($field->type!= 'share')
        {
            return;
        }
        if(!$field->field_value || $field->field_value == 'n') return;

        $params = new JParameter($field->params);
        $type = $field->type;


        $uri = JURI::getInstance();

        $bookmarkStyle = $params->get('bookmark_style', 'list');

        $article = $this->jsGetArticlesByFieldvalueID( $field->id );

        $uid = uniqid('bookmark');
        $out = '';
        $itemsPerRow = (int)$params->get('items_per_row', 0);

        $items = array();
        $onTop = array();
        for ($i = 1; $i <= 10; $i++)
        {
            $item = $params->get('bookmarkitem_'.$i);
            if ($item && is_array($item))
            {
                $onTop[ $i ] = @$item[ 1 ] == '1';
                $items[ $i ] = @unserialize($item[ 0 ]);
            }
            else
            {
                $onTop[ $i ] = false;
                $items[ $i ] = @unserialize($item);
            }
        }

        $replacements['needle'][] = '[*url*]';
        $replacements['replace'][] = $uri->toString();
        $replacements['needle'][] = '[*enc_url*]';
        $replacements['replace'][] = rawurlencode( $uri->toString() );
        $replacements['needle'][] = '[*title*]';
        $replacements['replace'][] = $article->title;
        $replacements['needle'][] = '[*enc_title*]';
        $replacements['replace'][] = urlencode( $article->title );
        $replacements['needle'][] = '[*metadescription*]';
        $replacements['replace'][] = $article->meta_descr;
        $replacements['needle'][] = '[*enc_metadescription*]';
        $replacements['replace'][] = urlencode( $article->meta_descr );



        $class = '';
        $style = '';
        $topLinks = array();
        if ($bookmarkStyle == 'popup')
        {
            $doc = & JFactory::getDocument();
            $doc->addStyleSheet(JURI::root().'plugins/joomsuite_content_fields/social_bookmark.css');
            JHTML::_('behavior.mootools');

            $out .= $this->getJS($uid);

            $class = ' class="mighty_social_bookmark_bg"';
            $style = ' style="display:none" ';
        }

        $out .= '<div id="'.$uid .'"'.$class.$style.'>';
    
        $i = 1;

        foreach( $items as $key => $item)
        {
            if (!$item)
                continue;

            $img = '<img src="'.JURI::root().'plugins/joomsuite_content_fields/images/jsbookmarks/'.$item['image'].'">';
            $href = str_replace( $replacements['needle'], $replacements['replace'], $item['url'] );
            //share.mail.ru
          
            if ($key == 8)
            {
                $bookmark='<a class="DiggThisButton DiggIcon"></a>
                <script src="http://digg.com/tools/diggthis.js" type="text/javascript"></script>';

            }
            else
            {
                
                $bookmark = '<a href="javascript:void(0);" target="blank" onclick="window.open(\''.$href.'\', \'_blank\', \'width='.@$item['width'].',height='.@$item['height'].'\');return false;">'.$img.'</a> ';
                if (@$onTop[ $key ])
                {
                    //'.$href.'
                    $topLinks[] = '<a href="javascript:void(0);" target="blank" onclick="window.open(\''.$href.'\', \'_blank\', \'width='.$item['width'].',height='.$item['height'].'\');return false;">
                    <span class="mighty_social_bookmark_top_image">'.$img.'</span>
                            </a> ';
                }
            }


            if (@$item['show'])
            {
                $out .= $bookmark;

                if ($itemsPerRow && $i && !($i % $itemsPerRow))
                    $out .= '<br />';

                $i++;
            }

        }

        $out .= '</div>';


        if ($bookmarkStyle == 'popup')
        {
            $bookmarkImage = $params->get('bookmark_image');
            if ($bookmarkImage && $bookmarkImage != '-1')
                $bookmarkImage = JHTML::image(JURI::root().'plugins/joomsuite_content_fields/images/shareicons/'.$params->get('bookmark_image'), JText::_('Share this'));
            else
                $bookmarkImage = '';

            $title = '<div id="control_'.$uid.'" class="mighty_social_bookmark" href="javascript:void(0);">'.
                    '<span class="mighty_social_bookmark_top_image">'.
                    $bookmarkImage.
                    '</span>'.
                    $params->get('title_for_popup', JText::_('Share')).
                    '<span>'.
                    implode('', $topLinks).
                    '</span>'.
                    '</div>';

            $out = $title.$out;
        }
    }

    function getJS($uid)
    {
        ob_start();
        ?>
<script type="text/javascript">
    window.addEvent('domready', function() {

        var toggler = new Fx.Slide('<?php echo $uid; ?>', {mode: 'vertical'});
        // toggler.hide();
        toggler.overBookmarks = false;
        toggler.overLink = false;

        var parent = $('<?php echo $uid; ?>').getParent();
        $('<?php echo $uid; ?>').setStyle('display', 'block');
        parent.remove();
        document.body.appendChild(parent);
        parent.setStyle('position', 'absolute');
        parent.setStyle('left', -5000);

        var closeIt = function() {
            if (toggler.overLink)
                return;

            toggler.slideOut().chain(function() {
                if (!toggler.open)
                    parent.setStyle('left', -5000);
            });
        }

        $('control_<?php echo $uid; ?>').addEvent('mouseenter', function() {
            var pos = $('control_<?php echo $uid; ?>').getPosition()
            parent.setStyle('left', pos.x + 'px');
            parent.setStyle('top', (pos.y + $('control_<?php echo $uid; ?>').offsetHeight + 10) + 'px');

            toggler.overLink = true;
            toggler.slideIn();
        });

        $('<?php echo $uid; ?>').addEvent('mouseenter', function() {
            toggler.show();
            toggler.overLink = true;
        });

        $$('#control_<?php echo $uid; ?>, #<?php echo $uid; ?>').addEvent('mouseleave', function() {
            toggler.overLink = false;
            closeIt.delay(1000);
        });
    });
</script>
        <?php

        return ob_get_clean();
    }

    function jsGetArticlesByFieldvalueID( $field_value_id )
    {
        $db			=& JFactory::getDBO();

        $sql = "    SELECT r.*"
                ."\n      FROM #__js_res_record_values AS fv"
                ."\n LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id"
                ."\n     WHERE fv.id = ".$field_value_id
        ;

        $db->setQuery( $sql );
        $result = $db->loadObjectList();
        return $result[0];
    }

}
?>