<?php
/**
 * @fileID: $Id: taber.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport ( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsTaber extends JPlugin {
	function plgJoomsuite_content_fieldsTaber(&$subject, $params) {
		parent::__construct ( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type) {
		if ($type != 'taber') return;
		global $mainframe;

		if($params->get('css'))
		{
			$document = & JFactory::getDocument ();
			$document->addStyleSheet ( JURI::root () . 'plugins/joomsuite_content_fields/taber_style.css' );
		}
		if (! $mainframe->isAdmin ()) {
			switch ($params->get ( 'type' )) {
				case 'taber' :
					$pane = & JPane::getInstance ( 'tabs' );
					break;

				case 'slider' :
					$pane = & JPane::getInstance ( 'sliders' );
					break;
			}
				
			switch ($params->get ( 'part' )) {
				case 'open' :
					echo $pane->startPane ( "menu-pane-".$params->get('taber_id') );
					echo $pane->startPanel ( JText::_($params->get('page_name')), $params->get('taber_id', "param-page") );
					break;

				case 'new_page' :
					echo $pane->endPanel ();
					echo $pane->startPanel ( JText::_($params->get('page_name')), $params->get('taber_id', "param-page") );
					break;

				case 'close' :
					echo $pane->endPanel ();
					echo $pane->endPane ();
					break;
			}
			echo '<input type="hidden" name="fields[' . $obj->id . ']" id="fields[' . $obj->id . ']" value="1">';
		} else {
			echo '<input type="text" name="fields[' . $obj->id . ']" id="fields[' . $obj->id . ']" value="1">';
		}

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error) {
		if ($type != 'taber')
		return;
		if (! $value)
		return;
		$db = &JFactory::getDBO ();
		$value = $db->getEscaped ( trim ( $value ) );
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;

		if ($type != 'taber')
			return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;

		if (JRequest::getInt ( 'print' ) == 1) {
			if (in_array ( $params->get ( 'part' ), array ('open', 'new_page' ) )) {
				$out = '<h3>' .JText::_($params->get ( 'page_name' )) . '</h3>';
			}
			return;
		}

		jimport ( 'joomla.html.pane' );
		$document = & JFactory::getDocument ();
		$document->addStyleSheet ( JURI::root () . 'plugins/joomsuite_content_fields/taber_style.css' );

		switch ($params->get ( 'type' )) {
			case 'taber' :
				$pane = & JPane::getInstance ( 'tabs' );
				break;
			case 'slider' :
				$pane = & JPane::getInstance ( 'sliders' );
				break;
		}

		switch ($params->get ( 'part' )) {
			case 'open' :
				$out .= $pane->startPane ( "menu-pane" );
				$out .= $pane->startPanel ( JText::_($params->get ( 'page_name' )), "param-page" );

				break;
			case 'new_page' :
				$out .= $pane->endPanel ();
				$out .= $pane->startPanel ( JText::_($params->get ( 'page_name' )), "param-page" );
				break;
			case 'close' :
				$out .= $pane->endPanel ();
				$out .= $pane->endPane ();
				break;
		}
	}
}